/******************************************************************************
 SCI Template Game
 By Brian Provinciano
 ******************************************************************************
 titlescreen.sc
 Contains the title screen room.
 ******************************************************************************/
(include "sci.sh")
/******************************************************************************/
(script 720)
/******************************************************************************/
(use "main")
(use "controls")
(use "room")
(use "user")
(use "obj")
/******************************************************************************/
(instance public TitleScreen of LLRoom
	(properties
		script 0
		number 0
		timer 0
		keep 0
		initialized 0
		lookStr 0
		picture scriptNumber
		style 65535
		horizon 0
		controls 0
		north 0
		east 0
		south 0
		west 0
		curPic 0
		picAngle 0
		vanishingX 160
		vanishingY 35536
		obstacles 0
	)
  (method (init) // method_000E
  		(send gGame:setCursor(900 1 350 185))
  		(send global_0045:disable())
  		(super:init())
  		(send global_0064:
  			//number(700)
  			loop(-1)
  			vol($7f)
  			flags(1)
  			//play()
  		)
  		(send global_0048:
  			addToFront(self))
  		(send global_0049:
  			addToFront(self))
  		(send gRoom:
  			style(42)
  		)
		Display(
			"Intro/Opening Screen"
			dsCOORD 90 80
			dsCOLOUR clWHITE
			dsBACKGROUND clTRANSPARENT
		)
  )
  (method (handleEvent pEvent)
 		(if(send pEvent:type)
 			(send pEvent:claimed(1))
 			(send gRoom:newRoom(100))
 		)
  )
  (method (newRoom param1)
      		(send global_0048:delete(self))
      		(send global_0049:delete(self))
      		(super:newRoom(param1))
  )
)
/******************************************************************************/
