/******************************************************************************/
(script 950)
/******************************************************************************/
(include "sci.sh")
/******************************************************************************/
(use "main")
(use "controls")
(use "polypath")
(use "obj")
/******************************************************************************/
(class CueObj of Script
	(properties
		client 0
		state -1
		start 0
		timer 0
		cycles 0
		seconds 0
		lastSeconds 0
		register 0
		script 0
		caller 0
		next 0
		theVerb 0
		theInvItem 0
	)
	(method (changeState newState)
		(switch(= state newState)
			(case 1
		    	(send global[0]:
		    		setHeading(
		    			GetAngle(
		    				(send global[0]:x)
		    				(send global[0]:y)
		    				(send client:x)
		    				(send client:y)
		    			)
		    			self
		    		)
		    	)
		    	(send global[$4E]:add(self))
			)
  			(case 2
  				= cycles 3
  			)
  			(case 3
		    	(send global[$4E]:delete(self))
		    	(if(client)
		    		(if(IsObject(send client:actions) and
		    		   (send (send client:actions):doVerb(theVerb theInvItem)))
		    		)(else
		    			(send client:doVerb(theVerb theInvItem))
		    		)
		    	)
  				= state 0
		    )
  		)
	)
)
/******************************************************************************/
(class Feature of Obj
	(properties
		x 0
		y 0
		z 0
		heading 0
		noun 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		description 0
		sightAngle $6789
		actions 0
		onMeCheck $6789
		approachX 0
		approachY 0
		approachDist 0
		{_approachVerbs} $6789
		lookStr 0
	)
	(method (init param1)
		(if(paramTotal and param1)
			(self:perform(param1))
		)(else
			(if(global[$40])
				(self:perform(global[$40]))
			)
		)
		(if(self:respondsTo(#underBits))
			(send gCast:add(self))
		)(else
			(send global[$20]:add(self))
		)
	)
	(method (dispose)
		(if(actions)
			(send actions:dispose())
			= actions 0
		)
		(send global[$20]:delete(self))
		(super:dispose())
	)
	(method (handleEvent pEvent)
		(var temp0,oInv)
		(if(send pEvent:claimed)
			return(TRUE)
		)
		(if(global[$45] and (== (send pEvent:message) 4) and (gInv))
		    = oInv (send gInv:
		    	indexOf(
		    		(send global[$45]:curInvIcon)	
		    	)
		   	 )
		)(else
		   	= oInv NULL
		)
		(if((== (send pEvent:type) $4000)
		 and (self:onMe(pEvent))
		 and (self:isNotHidden()))
		    (CueObj:
		    	state(0)
		    	cycles(0)
		    	client(self)
		    	theVerb(send pEvent:message)
		    	theInvItem(oInv)
		    )
			(send pEvent:claimed(TRUE))
			(if((send global[$50]:canControl)
			 and (<> _approachVerbs $6789)
		   	 and (+ _approachVerbs (<< (- (send pEvent:message) 1) 1)))
				(send global[0]:
		    		setMotion(
		    			PolyPath
		    			approachX
		    			(+ (send global[0]:z) approachY)
		    			CueObj
		    		)
		    	)
		    )(else
  				(send global[0]:setMotion(NULL))
  				(CueObj:changeState(3))
  			)
  		)
  		return(send pEvent:claimed)
	)
	(method (doVerb param1 params)
		(if(global[$41])
			(send global[$41]:doit(param1 self))	
		)(else		
			(dftDoVerb:doit(param1 self))	
		)
	)
	(method (notFacing)
		(var temp0)
		(send global[0]:setMotion(NULL))
		(CueObj:
			client(self)
			state(0)
			cycles(0)
			cue()
		)
	)
	(method (facingMe param1)
		(var temp0, temp1)
		(if(paramTotal)
			= temp0 param1
		)(else
			= temp0 global[0]
		)
		= temp1 Abs(- GetAngle((send temp0:x) (send temp0:y) x y) (send temp0:heading))
		(if(> temp1 180)
			= temp1 (- 360 temp1)
		)
		(if(<= temp1 sightAngle)
			return(TRUE)
		)
		(self:notFacing())
		return(FALSE)
	)
	(method (isNotHidden)
		return(TRUE)
	)
	(method (onMe param1 param2)
		(var temp0, temp1)
		(if(IsObject(param1))
		    = temp0 (send param1:x)
		    = temp1 (send param1:y)
		)(else
  			= temp0 param1
  			= temp1 param2
		)
		(if(IsObject(onMeCheck))
		    AvoidPath(temp0 temp1 onMeCheck)                                    
		)(else
			(if(nsLeft or nsRight or nsTop or nsBottom)
				(if((<= nsLeft temp0) and (<= temp0 nsRight) and (<= nsTop temp1) and (<= temp1 nsBottom))
					(if(<> onMeCheck $6789)
						return(& onMeCheck OnControl(4 temp0 temp1))
					)(else
						return(1)
					)
				)
			)(else
				(if(<> onMeCheck $6789)
					return(& onMeCheck OnControl(4 temp0 temp1))
				)(else
					return(1)
				)
			)
		)
	)
	(method (approachVerbs param1)
		(var temp0)
		= _approachVerbs 0
		= temp0 0 
  		(while(< temp0 paramTotal)
  			(if(param1)
  				(self:
  					_approachVerbs(
  						(| (self:_approachVerbs) (<< 1 (- param1[temp0] 1)))
  					)
  				)
  			)
  			++temp0
		)
	)
)
/******************************************************************************/
(instance dftDoVerb  of Code
	(method (doit param1 param2 param3) 
		(var temp0, temp1)
		= temp0 (send param2:description)
		(switch(param1)
			(case 2
				(if(send param2:lookStr)
		    		Print(send param2:lookStr)
		    	)(else
		    		FormatPrint("The %s looks like any other %s." temp0 temp0)
		    	)
			)
  			(case 4
  				(if(= temp1 (send gInv:at(param3)))
  					FormatPrint(
  						"You clicked inv item %s on %s."
  						(send temp1:description)
  						(temp0)
  					)
  				)
			)
  			(case 5
  				FormatPrint("The %s has nothing to say." temp0)
		    )
		)
	)
)
/******************************************************************************/
