/******************************************************************************/
(script 937)
/******************************************************************************/
(include "sci.sh")
/******************************************************************************/
(preload text)

(use "main")
(use "controls")
(use "obj")
/******************************************************************************/
(class IconI of Obj // $02CE
	(properties
		view -1
		loop -1
		cel -1
		nsLeft 0
		nsTop -1
		nsRight 0
		nsBottom 0
		state 0
		cursor -1
		type $4000
		message -1
		modifiers 0
		signal 1
		helpStr 0
		maskView 0
		maskLoop 0
		maskCel 0
		highlightColor 0
		lowlightColor 0
	)

	(method (show param1 param2)
		(var temp0, temp1, temp2, temp3, temp4, temp5, temp6)
		= signal (| signal $20)
		
		(if(paramTotal)
			= nsLeft param1
		    = nsRight (+ nsLeft CelWide(view loop cel))
			= nsTop param2
		    = nsBottom (+ nsTop CelHigh(view loop cel))
		)(else
		    = nsRight (+ nsLeft CelWide(view loop cel))
		    = nsBottom (+ nsTop CelHigh(view loop cel))
		)
		DrawCel(view loop cel nsLeft nsTop -1)
		(if(& signal 4)
			(self:mask())
		)
		(if(global[$4D] and (send global[$4D]:respondsTo(#stop)))
			(send global[$4d]:stop())
		)
	)
	(method (select param1)
		(var temp0, temp1)
		(if(& signal 4)
			return(FALSE)
		)
		(if(paramTotal and param1 and (& signal 1))
			DrawCel(view loop (= temp1 1) nsLeft nsTop -1)
			Graph(12 nsTop nsLeft nsBottom nsRight 1)
			
  			(while(<> (send (= temp (Event:new())):type) 2)
		    	(send temp0:localize())
		    	(if(self:onMe(temp0))
		    		(if(not(temp1))
		    			DrawCel(view loop (= temp1 1) nsLeft nsTop -1)
						Graph(12 nsTop nsLeft nsBottom nsRight 1)
					)
				)(else
		    		(if(temp1)
		    			DrawCel(view loop (= temp1 0) nsLeft nsTop -1)
						Graph(12 nsTop nsLeft nsBottom nsRight 1)
					)
				)
  				(send temp0:dispose())
		    )
  			(send temp0:dispose())
  			(if(== temp1 1)
		    	DrawCel(view loop 0 nsLeft nsTop -1)
				Graph(12 nsTop nsLeft nsBottom nsRight 1)
			)
		    return(temp1)
		)(else
			return(TRUE)
		)
	)
	(method (highlight param1)
		(var temp0, temp1, temp2, temp3, temp4)
		(if(not(& signal $20)) return)
		= temp4 
			(if(paramTotal and param1)
				highlightColor
			)(else
				lowlightColor
			)
		= temp0 (+ nsTop 2)
		= temp1 (+ nsLeft 2)
		= temp2 (- nsBottom 3)
		= temp3 (- nsRight 4)
		Graph(4 temp0 temp1 temp0 temp3 temp4 -1 -1)
		Graph(4 temp0 temp3 temp2 temp3 temp4 -1 -1)
		Graph(4 temp2 temp3 temp2 temp1 temp4 -1 -1)
		Graph(4 temp2 temp1 temp0 temp1 temp4 -1 -1)
		
		Graph(12
			(- nsTop 2)
			(- nsLeft 2)
			nsBottom
			(+ nsRight 3)
			1
		)
	)
	(method (onMe param1)
		(if((>= (send param1:x) nsLeft)
			and 
			(>= (send param1:y) nsTop)
			and 
			(<= (send param1:x) nsRight)
			and 
			(<= (send param1:y) nsBottom))
				return(TRUE)
		)
		return(FALSE)
	)
	(method (mask)
		DrawCel(
			maskView
			maskLoop
			maskCel
		    (+ nsLeft (/ (- CelWide(view loop cel) CelWide(maskView maskLoop maskCel)) 2))
		    (+ nsTop (/ (- CelHigh(view loop cel) CelHigh(maskView maskLoop maskCel)) 2))
			-1
		)
	)
)

/******************************************************************************/
(class IconBar of Set // $0DDC
	(properties
		elements 0
		size 0
		height 0
		underBits 0
		oldMouseX 0
		oldMouseY 0
		curIcon 0
		highlightedIcon 0
		prevIcon 0
		curInvIcon 0
		useIconItem 0
		helpIconItem 0
		port 0
		window 0
		state 0
		activateHeight 0
		y 0
		invLoop 1
	)
	(method (doit)
		(var temp0)
		(while((= temp0 (Event:new())) and (& state $20))
			(if(== (send temp0:type) $100)
		    	(if(& (send temp0:modifiers) 3)
		    		(send temp0:
		    			type(4)
		    			message(KEY_ESC)
		    			modifiers(0)
		    		)
		    	)(else
		    		(send temp0:
		    			type(4)
		    			message(KEY_RETURN)
		    			modifiers(0)
		    		)
		    	)
		    )
		    (if((send temp0:localize()) or (== (send temp0:type) 1) or ((== (send temp0:type) 4) and (== (send temp0:message) KEY_RETURN)))
  				(if(IsObject(helpIconItem) and (& (send helpIconItem:signal) $10))
		    		(send temp:
		    			type($4000)
		    			message(send helpIconItem:message)
		    		)
		    	)
		    )
  			MapKeyToDir(temp0)
  			(if(self:dispatchEvent(temp0))
  				break
  			)
		)
  		(if(IsObject(temp0))
			(send temp0:dispose())
		)
	)
	(method (handleEvent pEvent)
      (var temp0, temp1)
      
      	(send pEvent:localize())
      	
      	(if(& state 4) return)
      	
      	(if((if((not (= temp1 (send pEvent:type))) and (<= (send pEvent:y) height) and (not (= temp0 0)) ))
      		or
		    (if((== temp1 4) and (if((== (send pEvent:message) KEY_ESC) or (== (send pEvent:message) KEY_DELETE))))
		    	= temp0 1
		    )
		   )
			    = oldMouseX (send pEvent:x)
			    = oldMouseY (send pEvent:y)
			    (self:show())
			    
			    (if(temp0)
			    	(send gGame:
			    		setCursor(
			    			gCurrentCursor
			    			1
			    			(+ (send curIcon:nsLeft) (/ (- (send curIcon:nsRight) (send curIcon:nsLeft)) 2))
			    			(- (send curIcon:nsBottom) 13)
			    		)
			    	)
				)
				(self:doit())
				
				
			    (if(temp0)
			    	(send gGame:
			    		setCursor(
			    			(send curIcon:cursor)
			    			1
			    			oldMouseX
			    			oldMouseY
			    		)
			    	)
				)(else
					(send gGame:
						setCursor(
			    			(send curIcon:cursor)
			    			1
			    		)
			    	)
				)
				
				(self:hide())
		)(else	
  			(if(& temp1 4)
			    (switch(send pEvent:message)
			    	(case KEY_RETURN
			    		(if(IsObject(curIcon))
			    			(send pEvent:
			    				type(send curIcon:type)
			    				message(send curIcon:message)
			    			)
			    		)
			    	)
			    	(case KEY_INSERT
			    		(self:swapCurIcon())
			    		(send pEvent:claimed(TRUE))	
					)
					(case NULL
						(if(& (send pEvent:type) $40)
							(self:advanceCurIcon())
							(send pEvent:claimed(TRUE))
					    )
					)
	  			)
  			)(else
	  			(if(& temp1 1)
				    (if(& (send pEvent:modifiers) 3)
					    (self:advanceCurIcon())
					    (send pEvent:claimed(TRUE))
				    )(else
			  			(if(& (send pEvent:modifiers) 4)
						    (self:swapCurIcon())
						    (send pEvent:claimed(TRUE))
						)(else
			  				(if(IsObject(curIcon))
							    (send pEvent:
							    	type(send curIcon:type)
							    	message(send curIcon:message)
							    )
							)
						)
					)
			    )
			)
		)    
	)
	(method (show) // method_05E2
		(var temp0, temp1, temp2, temp3, temp4, temp5, temp6, temp7)
		
		(send gSounds:pause())

		= state (| state 32)
		
		(send gGame:setCursor(999 1))
		
		// Set the bar's height to the height of the first button's view
		= height CelHigh(
			(send(= temp0 (self:at(0))):view)
		    (send temp0:loop)
		    (send temp0:cel)
		)
		
		= port GetPort()
		SetPort(-1)
		
		= underBits Graph(7 y 0 (+ y height) 320 1)
		= temp1 PicNotValid()
		PicNotValid(TRUE)
		= temp3 0
		
		= temp4 y
		
		= temp5 FirstNode(elements)
		(while(temp5)
			= temp6 NextNode(temp5)
			(if(not IsObject(= temp7 NodeValue(temp5)))
				return
			)
			(if(<= (send temp7:nsRight) 0)
				(send temp7:show(temp3 temp4))
				= temp3 (send temp7:nsRight)
			)(else
				(send temp7:show())
			)
			= temp5 temp6
		)
		
		(if(curInvIcon)
		    (if(send global[0]:has((send gInv:indexOf(curInvIcon))))
			    = temp3
			    	(+
					    (/
						    (-
						    	(- (send useIconItem:nsRight) (send useIconItem:nsLeft))
						   	 	CelWide( (send curInvIcon:view)  (send curInvIcon:loop)  (send curInvIcon:cel)  )
						    )
						    2
						)
					    (send useIconItem:nsLeft)
			    	)
			    = temp4
				    (+
					    (+
						    y
						    (/ 
							    (-
								    (- (send useIconItem:nsBottom) (send useIconItem:nsTop))
									CelHigh( (send curInvIcon:view)  (send curInvIcon:loop)  (send curInvIcon:cel)  )
								) 
								2
							)   
						)
						(send useIconItem:nsTop)
					)
				DrawCel(
			    	(send curInvIcon:view)
			    	(+ (send curInvIcon:loop) invLoop)
			    	(send curInvIcon:cel)
			    	temp3
			    	temp4
			    	-1
			    )
			    
				(if(& (send useIconItem:signal) 4)
			    	(send useIconItem:mask)
			    )
			)(else
  				= curInvIcon NULL
  			)
		)
  
	    PicNotValid(temp1)
		Graph(12 y 0 (+ y height) 320 1)
		(self:highlight(curIcon))
		(send gGame:setCursor(
			gCurrentCursor
	    	(+ (send curIcon:nsLeft) (/ (- (send curIcon:nsLeft) (send curIcon:nsRight)) 2))
	    ))
	)
	(method (hide) // method_07E3
		(var temp0, temp1, temp2)
		
		(if(& state $20)
      		(send gSounds:pause())
      		= state (& state $FFdF)
		)
		= temp0 FirstNode(elements)
		
		(while(temp0)
		    = temp1 NextNode(temp0)
		    (if(not IsObject(= temp2 NodeValue(temp0)))
		    	return
		    )
		    (send (= temp2 NodeValue(temp0)):
		    	signal(& (send temp2:signal) $FFDF)
		    )
		    = temp0 temp1
		)
		
		Graph(8 underBits)
		Graph(12 y 0 (+ y height) 320 1)
		Graph(13 y 0 (+ y height) 320)
		SetPort(port)
		= height activateHeight
	)
	(method (advance)
		(var temp0, temp1)
		= temp1 1
		(while(<= temp1 size)
		    = temp0 (self:at(% (+ temp1 (self:indexOf(highlightedIcon))) size))
			(if(not IsObject(temp0))
				= temp0 NodeValue(self:first())
			)
			(if(not & (send temp0:signal) 4) break)
		    = temp1 (% (+ temp1 1) size)
		)
  		(if(& state 32)
		    (send gGame:setCursor(
		    	gCurrentCursor 
		    	1
		    	(+ (send temp0:nsLeft) (/ (- (send temp0:nsRight) (send temp0:nsLeft)) 2))
		    	(- (send temp0:nsBottom) 3)
		    ))
		)
  		(self:highlight(temp0))
	)
	(method (retreat)
		(var temp0, temp1)
		= temp1 1
		(while(<= temp1 size)
		    = temp0 (self:at(- (self:indexOf(highlightedIcon)) temp1))
			(if(not IsObject(temp0))
				= temp0 NodeValue(self:last())
			)
			(if(not & (send temp0:signal) 4) break)
		    = temp1 (% (+ temp1 1) size)
		)
  		(if(& state 32)
		    (send gGame:setCursor(
		    	gCurrentCursor 
		    	1
		    	(+ (send temp0:nsLeft) (/ (- (send temp0:nsRight) (send temp0:nsLeft)) 2))
		    	(- (send temp0:nsBottom) 3)
		    ))
		)
  		(self:highlight(temp0))
	)
	(method (select param1 param2)
		(if(send param1:select((if(>= paramTotal 2) param2 )))
			(if(not (& (send param1:signal) 2))
		    	= curIcon param1
			)
		    TRUE
		)
	)
	(method (highlight param1)
		(var temp0)
		(if(not (& (send param1:signal) 4))
			(if(IsObject(highlightedIcon))
				(send highlightedIcon:highlight(0))
			)
			= highlightedIcon param1
			(send highlightedIcon:highlight(1))
		)
	)
	(method (swapCurIcon)
		(var temp0)
		(if(& state 4)
      		return
		)
		
		(if((<> curIcon (= temp0 NodeValue(self:first))) and (not (& (send temp0:signal) 4)))
		    = prevIcon curIcon
		    
		    = curIcon NodeValue(self:first)
		)(else
			(if((prevIcon) and (not & (send prevIcon:signal) 4))
		    	= curIcon prevIcon
		    )
		)
		(send gGame:setCursor( (send curIcon:cursor) 1)) 
	)
	(method (advanceCurIcon)
		(var temp0, temp1)
		(if(& state 4)
			return
		)
		= temp0 curIcon
		= temp1 0
		
		(while(& (send (= temp0 (self:at(% (+ (self:indexOf(temp0)) 1) size))):signal) 6)
		    (if(> temp1 (+ 1 size))
		    	return
		    )
		    ++temp1 
		)
  		= curIcon temp0
  		(send gGame:setCursor(
  			(send curIcon:cursor)
  			1
  		))
	)
	(method (dispatchEvent pEvent)
		(var temp0, temp1, temp2, temp3, temp4, temp5)

		= temp0 (send pEvent:y)
		= temp1 (send pEvent:type)
		= temp2 (send pEvent:message)
		= temp4 (send pEvent:claimed)
		= temp3 (self:firstTrue(#onMe pEvent))

		(send pEvent:dispose())
		
		(if(& temp1 $40)
			(switch(temp2)
				(case 3
					(self:advance())
				)
				(case 7
					(self:retreat())
				)
			)
		)(else
			(switch(temp1)
				(case 0
		    		(if(> temp0 (+ y height))
		    			(if( (not IsObject(helpIconItem)) or (not (& (send helpIconItem:signal) $10)) )
					    	= oldMouseY 0
					    	= temp4 1
					    )
				    )(else
				    	(if(temp3 and (<> temp3 highlightedIcon))
				    		= oldMouseY 0
				    		(self:highlight(temp3))
					    )
					)
  				)
  				(case 1
				    (if((temp3) and (self:select(temp3 1)))	
					    (if(== temp3 helpIconItem)
						    (if(send temp3:cursor)
						    	(send gGame:setCursor(send temp3:cursor))
							)
							(send helpIconItem:
								signal(
									| (send helpIconItem:signal) $10
								)
							)
						)(else
							= temp4 (& (send temp3:signal) $40)
					    )
					)
				)
  				(case 4
  					(switch(temp2)
  						(case KEY_ESC
  							= temp4 1
						)
						(case KEY_RETURN
							(if(not temp3)
								= temp3 highlightedIcon
							)
							(if(temp3 and (== temp3 helpIconItem))
								    (if(<> (send temp3:cursor) -1)
								   	 	(send gGame:setCursor(send temp3:cursor))						
									)
									(if(helpIconItem)
										(send helpIconItem:
											signal(| (send helpIconItem:signal) $10)
										)
								    )
							)(else
								(if(IsObject(temp3))
									(self:select(temp3))
									= temp4 (& (send temp3:signal) $40)
								)
							)
						)
		  				(case $F00
		  					(self:retreat())
						)
						(case KEY_TAB
		  					(self:advance())
						)
					)
				)
  				(case $4000
  					(if(== temp2 6)
					    (if((temp3) and (send temp3:helpStr))	
						    = temp5 GetPort()
						    FormatPrint(937 0 (send temp3:helpStr))
						    SetPort(temp5)	
					   	) 	
					    (if(helpIconItem)
					    	(send helpIconItem:
					    		signal( & (send helpIconItem:signal) $FFEF )
					    	)			
						)
						(send gGame:setCursor(999))
					)
				)
			)
		)
		return(temp4)
	)
	(method (disable param1)
		(var temp0, temp1)
		(if(paramTotal)
			= temp0 0
			(while(< temp0 paramTotal)
				= temp1
					(if(IsObject(param1[temp0]))	
						param1[temp0]
					)(else
						(self:at(param1[temp0]))
					)
				(send temp1:
					signal( | (send temp1:signal) 4 )
				)
				(if(== temp1 curIcon)
					(self:advanceCurIcon())
				)(else
					(if(== temp1 highlightedIcon)
						(self:advance())
					)
				)
			    ++temp0 
		    )
		)(else
			= state (| state 4)
		)
	)
	(method (enable param1)
		(var temp0, temp1)
		(if(paramTotal)
			= temp0 0
			(while(< temp0 paramTotal)
				= temp1
					(if(IsObject(param1[temp0]))	
						param1[temp0]
					)(else
						(self:at(param1[temp0]))
					)
				(send temp1:
					signal( & (send temp1:signal) $FFFB )
				)
			    ++temp0 
		    )
		)(else
			= state (& state $FFFB)
		)/*
      (var temp0, temp1)
      (asm
		    lap paramTotal 
		    bnt code_05DA
		    ldi 0 // $0 species
		    sat temp0 
  code_059C:
		    lst temp0 
		    lap paramTotal 
		    lt?
		    bnt code_05E1
		    push1
		    lat temp0 
		    lspi 1 /*param1*/ /*
		    callk IsObject 2

		    bnt code_05B6
		    lat temp0 
		    lapi 1 /*param1*/ /*
		    jmp code_05BF
  code_05B6:
		    pushi 67 // $43 at
		    push1
		    lat temp0 
		    lspi 1 /*param1*/ /*
		    self 6

  code_05BF:
		    sat temp1 
		    pushi 17 // $11 signal
		    push1
		    pushi 17 // $11 signal
		    push0
		    send 4

		    push
		    ldi -5 // $FFFB 
		    and
		    push
		    lat temp1 
		    send 6

		    +at temp0 
		    jmp code_059C
		    jmp code_05E1
  code_05DA:
		    pTos state
		    ldi -5 // $FFFB 
		    and
		    aTop state
  code_05E1:
		    ret
      )*/
	)
)

/******************************************************************************/
