/******************************************************************************/
(script 937)
/******************************************************************************/
(include "sci.sh")
/******************************************************************************/
(use "main")
(use "controls")
(use "obj")
/******************************************************************************/
(class IconI of Obj
	(properties
		view -1
		loop -1
		cel -1
		nsLeft 0
		nsTop -1
		nsRight 0
		nsBottom 0
		state 0
		cursor -1
		type $4000
		message -1
		modifiers 0
		signal 1
		helpStr 0
		maskView 0
		maskLoop 0
		maskCel 0
		highlightColor 0
		lowlightColor 0
	)

	(method (show param1 param2)
		(var temp0, temp1, temp2, temp3, temp4, temp5, temp6)
		= signal (| signal $20)
		
		(if(paramTotal)
			= nsLeft param1
		    = nsRight (+ nsLeft CelWide(view loop cel))
			= nsTop param2
		    = nsBottom (+ nsTop CelHigh(view loop cel))
		)(else
		    = nsRight (+ nsLeft CelWide(view loop cel))
		    = nsBottom (+ nsTop CelHigh(view loop cel))
		)
		DrawCel(view loop cel nsLeft nsTop -1)
		(if(& signal 4)
			(self:mask())
		)
		(if(global[$4D] and (send global[$4D]:respondsTo(#stop)))
			(send global[$4d]:stop())
		)
	)
	(method (select param1)
		(var temp0, temp1)
		(if(& signal 4)
			return(FALSE)
		)
		(if(paramTotal and param1 and (& signal 1))
			DrawCel(view loop (= temp1 1) nsLeft nsTop -1)
			Graph(12 nsTop nsLeft nsBottom nsRight 1)
			
  			(while(<> (send (= temp (Event:new())):type) 2)
		    	(send temp0:localize())
		    	(if(self:onMe(temp0))
		    		(if(not(temp1))
		    			DrawCel(view loop (= temp1 1) nsLeft nsTop -1)
						Graph(12 nsTop nsLeft nsBottom nsRight 1)
					)
				)(else
		    		(if(temp1)
		    			DrawCel(view loop (= temp1 0) nsLeft nsTop -1)
						Graph(12 nsTop nsLeft nsBottom nsRight 1)
					)
				)
  				(send temp0:dispose())
		    )
  			(send temp0:dispose())
  			(if(== temp1 1)
		    	DrawCel(view loop 0 nsLeft nsTop -1)
				Graph(12 nsTop nsLeft nsBottom nsRight)
			)
		    return(temp1)
		)(else
			return(TRUE)
		)
	)
	(method (highlight param1)
		(var temp0, temp1, temp2, temp3, temp4)
		(if(not(& signal $20)) return)
		(if(paramTotal)
			= temp4 (= highlightColor param1)
		)(else
			= temp4 param1
		)
		= temp0 (+ nsTop 2)
		= temp1 (+ nsLeft 2)
		= temp2 (- nsBottom 2)
		= temp3 (- nsRight 2)
		Graph(4 temp0 temp1 temp0 temp3 temp4 -1 -1)
		Graph(4 temp0 temp3 temp2 temp3 temp4 -1 -1)
		Graph(4 temp2 temp3 temp2 temp1 temp4 -1 -1)
		Graph(4 temp2 temp1 temp0 temp1 temp4 -1 -1)
		
		Graph(12
			(- nsTop 2)
			(- nsLeft 2)
			nsBottom
			(+ nsRight 3)
			1
		)
	)
	(method (onMe param1)
		(if((>= (send param1:x) nsLeft)
			and 
			(>= (send param1:y) nsTop)
			and 
			(<= (send param1:x) nsRight)
			and 
			(<= (send param1:y) nsBottom))
				return(TRUE)
		)
		return(FALSE)
	)
	(method (mask)
		DrawCel(
			maskView
			maskLoop
			maskCel
		    (+ nsLeft (/ (- CelWide(view loop cel) CelWide(maskView maskLoop maskCel)) 2))
		    (+ nsTop (/ (- CelHigh(view loop cel) CelHigh(maskView maskLoop maskCel)) 2))
			-1
		)
	)
)
/******************************************************************************/
(class IconBar of Set
	(properties
		elements 0
		size 0
		height 0
		underBits 0
		oldMouseX 0
		oldMouseY 0
		curIcon 0
		highlightedIcon 0
		prevIcon 0
		curInvIcon 0
		useIconItem 0
		helpIconItem 0
		port 0
		window 0
		state 0
		activateHeight 0
		y 0
		invLoop 1
	)
	(method (doit)
		(var temp0)
		(while((= temp0 (Event:new())) and (& state $20))
			(if(== (send temp0:type) $100)
		    	(if(& (send temp0:modifiers) 3)
		    		(send temp0:
		    			type(4)
		    			message(KEY_ESC)
		    			modifiers(0)
		    		)
		    	)(else
		    		(send temp0:
		    			type(4)
		    			message(KEY_ENTER)
		    			modifiers(0)
		    		)
		    	)
		    )
		    (if((send temp0:localize()) or (== (send temp0:type) 1) or ((== (send temp0:type) 4) and (== (send temp0:message) KEY_ENTER)))
  				(if(IsObject(helpIconItem) and (& (send helpIconItem:signal) $10))
		    		(send temp:
		    			type($4000)
		    			message(send helpIconItem:message)
		    		)
		    	)
		    )
  			MapKeyToDir(temp0)
  			(if(self:dispatchEvent(temp0))
  				break
  			)
		)
  		(if(IsObject(temp0))
			(send temp0:dispose())
		)
	)
	(method (handleEvent pEvent)
		(var temp0, temp1)
		(send pEvent:localize())
		(if(& state 4)
		)(else
			not(= temp1 (send pEvent:type))
		    bnt code_037B
		    (<= (send pEvent:y) height)
		    bnt code_037B
		    not(= temp0 0)
  code_037B:
		    bt code_03A7
		    (== temp1 4)
		    bnt code_043A
		    (== (send pEvent:message) KEY_ENTER)
		    bt code_03A0
		    (== (send pEvent:message) KEY_DELETE)
  code_03A0:
		    bnt code_043A
		    (= temp0 1)
  code_03A7:
		    bnt code_043A
		    (= oldMouseX (send pEvent:x)
		    (= oldMouseY (send pEvent:y)
		    (self:show())
		    (temp0) 
		    bnt code_03FD
		    (send gGame:setCursor(
		    	gCurrentCursor
		    	TRUE
		    	(+ (send curIcon:nsLeft) 
		       		(/ (- (send curIcon:nsRight) (send curIcon:nsLeft)) 2))
		   		(- (send curIcon:nsBottom) 13)
		   	)
  code_03FD:
  			(self:doit())
  			(temp0) 
		    bnt code_0420
		    (send gGame:setCursor(
		    	(send curIcon:cursor)
		   	 	TRUE
		    	oldMouseX
		    	oldMouseY
		   	)
		    jmp code_0431
  code_0420:
		    (send gGame:setCursor(
		    	(send curIcon:cursor)
		   	 	TRUE
		   	)
  code_0431:
  			(self:hide())
		    jmp code_0520
  code_043A:
  			(& temp1 4)
		    bnt code_04B7
		    (switch(send pEvent:message)
		    	(case KEY_ENTER
		    push1
		    pTos curIcon
		    callk IsObject 2

		    bnt code_04B3
		    pushi 34 // $22 type
		    push1
		    pushi 34 // $22 type
		    push0
		    pToa curIcon
		    send 4

		    push
		    pushi 40 // $28 message
		    push1
		    pushi 40 // $28 message
		    push0
		    pToa curIcon
		    send 4

		    push
		    lap param1 
		    send 12
			)
			(case KEY_INSERT
		    pushi 194 // $C2 swapCurIcon
		    push0
		    self 4

		    pushi 76 // $4C claimed
		    push1
		    push1
		    lap param1 
		    send 6

			)
			(case 0
		    pushi 34 // $22 type
		    push0
		    lap param1 
		    send 4

		    push
		    ldi 64 // $40 modifiers
		    and
		    bnt code_04B3
		    pushi 195 // $C3 advanceCurIcon
		    push0
		    self 4

		    pushi 76 // $4C claimed
		    push1
		    push1
		    lap param1 
		    send 6
			)
		)
		    jmp code_0520
  code_04B7:
			(& temp1 1)
		    bnt code_0520
		    (& (send pEvent:modifiers) 3)
		    bnt code_04DE
		    (self:advanceCurIcon())
		    (send pEvent:claimed(TRUE))
		    jmp code_0520
  code_04DE:
  			(& (send pEvent:modifiers) 4)
		    bnt code_04FD
		    (self:swapCurIcon())
		    (send pEvent:claimed(TRUE))
		    jmp code_0520
  code_04FD:
  			(if(IsObject(curIcon))
  				(send pEvent:
  					type(send curIcon:type)
		    		message(send curIcon:message)
				)
		    )
		)
  code_0520:
	)/*
	(method (show) // method_05E2
		(var temp0, temp1, temp2, temp3, temp4, temp5, temp6, temp7
		    )
		    pushi 152 // $98 pause
		    push0
		    lag global_0008 
		    send 4

		    pTos state
		    ldi 32 // $20 state
		    or
		    aTop state
		    pushi 183 // $B7 setCursor
		    push2
		    pushi 999 // $3E7 
		    push1
		    lag global_0001 
		    send 8

		    pushi 3 // $3 y
		    pushi 5 // $5 view
		    push0
		    pushi 67 // $43 at
		    push1
		    push0
		    self 6

		    sat temp0 
		    send 4

		    push
		    pushi 6 // $6 loop
		    push0
		    lat temp0 
		    send 4

		    push
		    pushi 7 // $7 cel
		    push0
		    lat temp0 
		    send 4

		    push
		    callk CelHigh 6

		    aTop height
		    push0
		    callk GetPort 0

		    aTop port
		    push1
		    pushi -1 // $FFFF 
		    callk SetPort 2

		    pushi 6 // $6 loop
		    pushi 7 // $7 cel
		    pTos y
		    push0
		    pTos y
		    pToa height
		    add
		    push
		    pushi 320 // $140 theObj
		    push1
		    callk Graph 12

		    aTop underBits
		    push0
		    callk PicNotValid 0

		    sat temp1 
		    push1
		    push1
		    callk PicNotValid 2

		    ldi 0 // $0 species
		    sat temp3 
		    pToa y
		    sat temp4 
		    push1
		    pTos elements
		    callk FirstNode 2

		    sat temp5 
  code_0661:
		    lat temp5 
		    bnt code_06B4
		    push1
		    push
		    callk NextNode 2

		    sat temp6 
		    push1
		    push1
		    lst temp5 
		    callk NodeValue 2

		    sat temp7 
		    push
		    callk IsObject 2

		    not
		    bnt code_067F
		    ret
  code_067F:
		    pushi 12 // $C nsRight
		    push0
		    lat temp7 
		    send 4

		    push
		    ldi 0 // $0 species
		    le?
		    bnt code_06A5
		    pushi 190 // $BE show
		    push2
		    lst temp3 
		    lst temp4 
		    lat temp7 
		    send 8

		    pushi 12 // $C nsRight
		    push0
		    lat temp7 
		    send 4

		    sat temp3 
		    jmp code_06AD
  code_06A5:
		    pushi 190 // $BE show
		    push0
		    lat temp7 
		    send 4

  code_06AD:
		    lat temp6 
		    sat temp5 
		    jmp code_0661
  code_06B4:
		    pToa curInvIcon
		    bnt code_0798
		    pushi 208 // $D0 has
		    push1
		    pushi 125 // $7D indexOf
		    push1
		    push
		    lag global_0009 
		    send 6

		    push
		    lag global_0000 
		    send 6

		    bnt code_0794
		    pushi 12 // $C nsRight
		    push0
		    pToa useIconItem
		    send 4

		    push
		    pushi 10 // $A nsLeft
		    push0
		    pToa useIconItem
		    send 4

		    sub
		    push
		    pushi 3 // $3 y
		    pushi 5 // $5 view
		    push0
		    pToa curInvIcon
		    send 4

		    push
		    pushi 6 // $6 loop
		    push0
		    pToa curInvIcon
		    send 4

		    push
		    pToa invLoop
		    add
		    push
		    pushi 7 // $7 cel
		    push0
		    pToa curInvIcon
		    send 4

		    push
		    callk CelWide 6

		    sub
		    push
		    ldi 2 // $2 -info-
		    div
		    push
		    pushi 10 // $A nsLeft
		    push0
		    pToa useIconItem
		    send 4

		    add
		    sat temp3 
		    pTos y
		    pushi 11 // $B nsBottom
		    push0
		    pToa useIconItem
		    send 4

		    push
		    pushi 9 // $9 nsTop
		    push0
		    pToa useIconItem
		    send 4

		    sub
		    push
		    pushi 3 // $3 y
		    pushi 5 // $5 view
		    push0
		    pToa curInvIcon
		    send 4

		    push
		    pushi 6 // $6 loop
		    push0
		    pToa curInvIcon
		    send 4

		    push
		    pToa invLoop
		    add
		    push
		    pushi 7 // $7 cel
		    push0
		    pToa curInvIcon
		    send 4

		    push
		    callk CelHigh 6

		    sub
		    push
		    ldi 2 // $2 -info-
		    div
		    add
		    push
		    pushi 9 // $9 nsTop
		    push0
		    pToa useIconItem
		    send 4

		    add
		    sat temp4 
		    pushi 6 // $6 loop
		    pushi 5 // $5 view
		    push0
		    pToa curInvIcon
		    send 4

		    push
		    pushi 6 // $6 loop
		    push0
		    pToa curInvIcon
		    send 4

		    push
		    pToa invLoop
		    add
		    push
		    pushi 7 // $7 cel
		    push0
		    pToa curInvIcon
		    send 4

		    push
		    lst temp3 
		    lst temp4 
		    pushi -1 // $FFFF 
		    callk DrawCel 12

		    pushi 17 // $11 signal
		    push0
		    pToa useIconItem
		    send 4

		    push
		    ldi 4 // $4 x
		    and
		    bnt code_0798
		    pushi 193 // $C1 mask
		    push0
		    pToa useIconItem
		    send 4

		    jmp code_0798
  code_0794:
		    ldi 0 // $0 species
		    aTop curInvIcon
  code_0798:
		    push1
		    lst temp1 
		    callk PicNotValid 2

		    pushi 6 // $6 loop
		    pushi 12 // $C nsRight
		    pTos y
		    push0
		    pTos y
		    pToa height
		    add
		    push
		    pushi 320 // $140 theObj
		    push1
		    callk Graph 12

		    pushi 191 // $BF highlight
		    push1
		    pTos curIcon
		    self 6

		    pushi 183 // $B7 setCursor
		    push2
		    lsg global_0013 
		    pushi 10 // $A nsLeft
		    push0
		    pToa curIcon
		    send 4

		    push
		    pushi 10 // $A nsLeft
		    push0
		    pToa curIcon
		    send 4

		    push
		    pushi 12 // $C nsRight
		    push0
		    pToa curIcon
		    send 4

		    sub
		    push
		    ldi 2 // $2 -info-
		    div
		    add
		    push
		    lag global_0001 
		    send 8

		    ret
	)
	(method (hide) // method_07E3
		(var temp0, temp1, temp2)
		    pTos state
		    ldi 32 // $20 state
		    and
		    bnt code_07FD
		    pushi 152 // $98 pause
		    push1
		    push0
		    lag global_0008 
		    send 6

		    pTos state
		    ldi -33 // $FFDF 
		    and
		    aTop state
  code_07FD:
		    push1
		    pTos elements
		    callk FirstNode 2

		    sat temp0 
  code_0805:
		    lat temp0 
		    bnt code_0843
		    push1
		    push
		    callk NextNode 2

		    sat temp1 
		    push1
		    push1
		    lst temp0 
		    callk NodeValue 2

		    sat temp2 
		    push
		    callk IsObject 2

		    not
		    bnt code_0823
		    ret
  code_0823:
		    pushi 17 // $11 signal
		    push1
		    pushi 17 // $11 signal
		    push0
		    lat temp2 
		    send 4

		    push
		    ldi -33 // $FFDF 
		    and
		    push
		    push1
		    lst temp0 
		    callk NodeValue 2

		    sat temp2 
		    send 6

		    lat temp1 
		    sat temp0 
		    jmp code_0805
  code_0843:
		    push2
		    pushi 8 // $8 underBits
		    pTos underBits
		    callk Graph 4

		    pushi 6 // $6 loop
		    pushi 12 // $C nsRight
		    pTos y
		    push0
		    pTos y
		    pToa height
		    add
		    push
		    pushi 320 // $140 theObj
		    push1
		    callk Graph 12

		    pushi 5 // $5 view
		    pushi 13 // $D lsTop
		    pTos y
		    push0
		    pTos y
		    pToa height
		    add
		    push
		    pushi 320 // $140 theObj
		    callk Graph 10

		    push1
		    pTos port
		    callk SetPort 2

		    pToa activateHeight
		    aTop height
		    ret
	)
	(method (advance) // method_0B74
		(var temp0, temp1)
		    ldi 1 // $1 superClass
		    sat temp1 
  code_0B7A:
		    lst temp1 
		    pToa size
		    le?
		    bnt code_0BCA
		    pushi 67 // $43 at
		    push1
		    lst temp1 
		    pushi 125 // $7D indexOf
		    push1
		    pTos highlightedIcon
		    self 6

		    add
		    push
		    pToa size
		    mod
		    push
		    self 6

		    sat temp0 
		    push1
		    push
		    callk IsObject 2

		    not
		    bnt code_0BAD
		    push1
		    pushi 118 // $76 first
		    push0
		    self 4

		    push
		    callk NodeValue 2

		    sat temp0 
  code_0BAD:
		    pushi 17 // $11 signal
		    push0
		    lat temp0 
		    send 4

		    push
		    ldi 4 // $4 x
		    and
		    not
		    bt code_0BCA
		    lst temp1 
		    ldi 1 // $1 superClass
		    add
		    push
		    pToa size
		    mod
		    sat temp1 
		    jmp code_0B7A
  code_0BCA:
		    pTos state
		    ldi 32 // $20 state
		    and
		    bnt code_0C08
		    pushi 183 // $B7 setCursor
		    pushi 4 // $4 x
		    lsg global_0013 
		    push1
		    pushi 10 // $A nsLeft
		    push0
		    lat temp0 
		    send 4

		    push
		    pushi 12 // $C nsRight
		    push0
		    lat temp0 
		    send 4

		    push
		    pushi 10 // $A nsLeft
		    push0
		    lat temp0 
		    send 4

		    sub
		    push
		    ldi 2 // $2 -info-
		    div
		    add
		    push
		    pushi 11 // $B nsBottom
		    push0
		    lat temp0 
		    send 4

		    push
		    ldi 3 // $3 y
		    sub
		    push
		    lag global_0001 
		    send 12

  code_0C08:
		    pushi 191 // $BF highlight
		    push1
		    lst temp0 
		    self 6

		    ret
	)
	(method (retreat) // method_0C11
		(var temp0, temp1)
		    ldi 1 // $1 superClass
		    sat temp1 
  code_0C17:
		    lst temp1 
		    pToa size
		    le?
		    bnt code_0C64
		    pushi 67 // $43 at
		    push1
		    pushi 125 // $7D indexOf
		    push1
		    pTos highlightedIcon
		    self 6

		    push
		    lat temp1 
		    sub
		    push
		    self 6

		    sat temp0 
		    push1
		    push
		    callk IsObject 2

		    not
		    bnt code_0C47
		    push1
		    pushi 120 // $78 last
		    push0
		    self 4

		    push
		    callk NodeValue 2

		    sat temp0 
  code_0C47:
		    pushi 17 // $11 signal
		    push0
		    lat temp0 
		    send 4

		    push
		    ldi 4 // $4 x
		    and
		    not
		    bt code_0C64
		    lst temp1 
		    ldi 1 // $1 superClass
		    add
		    push
		    pToa size
		    mod
		    sat temp1 
		    jmp code_0C17
  code_0C64:
		    pTos state
		    ldi 32 // $20 state
		    and
		    bnt code_0CA2
		    pushi 183 // $B7 setCursor
		    pushi 4 // $4 x
		    lsg global_0013 
		    push1
		    pushi 10 // $A nsLeft
		    push0
		    lat temp0 
		    send 4

		    push
		    pushi 12 // $C nsRight
		    push0
		    lat temp0 
		    send 4

		    push
		    pushi 10 // $A nsLeft
		    push0
		    lat temp0 
		    send 4

		    sub
		    push
		    ldi 2 // $2 -info-
		    div
		    add
		    push
		    pushi 11 // $B nsBottom
		    push0
		    lat temp0 
		    send 4

		    push
		    ldi 3 // $3 y
		    sub
		    push
		    lag global_0001 
		    send 12

  code_0CA2:
		    pushi 191 // $BF highlight
		    push1
		    lst temp0 
		    self 6

		    ret
	)
	(method (select) // method_0CAB
		    pushi 164 // $A4 select
		    push1
		    lsp paramTotal 
		    ldi 2 // $2 -info-
		    ge?
		    bnt code_0CB9
		    lap param2 
  code_0CB9:
		    push
		    lap param1 
		    send 6

		    bnt code_0CD6
		    pushi 17 // $11 signal
		    push0
		    lap param1 
		    send 4

		    push
		    ldi 2 // $2 -info-
		    and
		    not
		    bnt code_0CD4
		    lap param1 
		    aTop curIcon
  code_0CD4:
		    ldi 1 // $1 superClass
  code_0CD6:
		    ret
	)
	(method (highlight) // method_0CD7
		(var temp0)
		    pushi 17 // $11 signal
		    push0
		    lap param1 
		    send 4

		    push
		    ldi 4 // $4 x
		    and
		    not
		    bnt code_0D05
		    push1
		    pTos highlightedIcon
		    callk IsObject 2

		    bnt code_0CFA
		    pushi 191 // $BF highlight
		    push1
		    push0
		    pToa highlightedIcon
		    send 6

  code_0CFA:
		    lap param1 
		    aTop highlightedIcon
		    pushi 191 // $BF highlight
		    push1
		    push1
		    send 6

  code_0D05:
		    ret
	)
	(method (swapCurIcon) // method_0D65
		(var temp0)
		    pTos state
		    ldi 4 // $4 x
		    and
		    bnt code_0D73
		    ret
		    jmp code_0DBD
  code_0D73:
		    pTos curIcon
		    push1
		    pushi 118 // $76 first
		    push0
		    self 4

		    push
		    callk NodeValue 2

		    sat temp0 
		    ne?
		    bnt code_0DA7
		    pushi 17 // $11 signal
		    push0
		    lat temp0 
		    send 4

		    push
		    ldi 4 // $4 x
		    and
		    not
		    bnt code_0DA7
		    pToa curIcon
		    aTop prevIcon
		    push1
		    pushi 118 // $76 first
		    push0
		    self 4

		    push
		    callk NodeValue 2

		    aTop curIcon
		    jmp code_0DBD
  code_0DA7:
		    pToa prevIcon
		    bnt code_0DBD
		    pushi 17 // $11 signal
		    push0
		    send 4

		    push
		    ldi 4 // $4 x
		    and
		    not
		    bnt code_0DBD
		    pToa prevIcon
		    aTop curIcon
  code_0DBD:
		    pushi 183 // $B7 setCursor
		    push2
		    pushi 36 // $24 cursor
		    push0
		    pToa curIcon
		    send 4

		    push
		    push1
		    lag global_0001 
		    send 8

		    ret
	)
	(method (advanceCurIcon) // method_0D06
		(var temp0, temp1)
		    pTos state
		    ldi 4 // $4 x
		    and
		    bnt code_0D11
		    ret
  code_0D11:
		    pToa curIcon
		    sat temp0 
		    ldi 0 // $0 species
		    sat temp1 
  code_0D19:
		    pushi 17 // $11 signal
		    push0
		    pushi 67 // $43 at
		    push1
		    pushi 125 // $7D indexOf
		    push1
		    lst temp0 
		    self 6

		    push
		    ldi 1 // $1 superClass
		    add
		    push
		    pToa size
		    mod
		    push
		    self 6

		    sat temp0 
		    send 4

		    push
		    ldi 6 // $6 loop
		    and
		    bnt code_0D4F
		    lst temp1 
		    push1
		    pToa size
		    add
		    gt?
		    bnt code_0D4A
		    ret
		    jmp code_0D19
  code_0D4A:
		    +at temp1 
		    jmp code_0D19
  code_0D4F:
		    lat temp0 
		    aTop curIcon
		    pushi 183 // $B7 setCursor
		    push2
		    pushi 36 // $24 cursor
		    push0
		    pToa curIcon
		    send 4

		    push
		    push1
		    lag global_0001 
		    send 8

		    ret
	)
	(method (dispatchEvent) // method_094E
		(var temp0, temp1, temp2, temp3, temp4, temp5)
		    pushi 3 // $3 y
		    push0
		    lap param1 
		    send 4

		    sat temp0 
		    pushi 34 // $22 type
		    push0
		    lap param1 
		    send 4

		    sat temp1 
		    pushi 40 // $28 message
		    push0
		    lap param1 
		    send 4

		    sat temp2 
		    pushi 76 // $4C claimed
		    push0
		    lap param1 
		    send 4

		    sat temp4 
		    pushi 114 // $72 firstTrue
		    push2
		    pushi 192 // $C0 onMe
		    lsp param1 
		    self 8

		    sat temp3 
		    pushi 105 // $69 dispose
		    push0
		    lap param1 
		    send 4

		    lst temp1 
		    ldi 64 // $40 modifiers
		    and
		    bnt code_09B2
		    lst temp2 
		    dup
		    ldi 3 // $3 y
		    eq?
		    bnt code_09A1
		    pushi 173 // $AD advance
		    push0
		    self 4

		    jmp code_09AE
  code_09A1:
		    dup
		    ldi 7 // $7 cel
		    eq?
		    bnt code_09AE
		    pushi 174 // $AE retreat
		    push0
		    self 4

  code_09AE:
		    toss
		    jmp code_0B71
  code_09B2:
		    lst temp1 
		    dup
		    ldi 0 // $0 species
		    eq?
		    bnt code_0A05
		    lst temp0 
		    pTos y
		    pToa height
		    add
		    gt?
		    bnt code_09EA
		    push1
		    pTos helpIconItem
		    callk IsObject 2

		    not
		    bt code_09DC
		    pushi 17 // $11 signal
		    push0
		    pToa helpIconItem
		    send 4

		    push
		    ldi 16 // $10 lsRight
		    and
		    not
  code_09DC:
		    bnt code_0B70
		    ldi 0 // $0 species
		    aTop oldMouseY
		    ldi 1 // $1 superClass
		    sat temp4 
		    jmp code_0B70
  code_09EA:
		    lat temp3 
		    bnt code_0B70
		    push
		    pToa highlightedIcon
		    ne?
		    bnt code_0B70
		    ldi 0 // $0 species
		    aTop oldMouseY
		    pushi 191 // $BF highlight
		    push1
		    lst temp3 
		    self 6

		    jmp code_0B70
  code_0A05:
		    dup
		    ldi 1 // $1 superClass
		    eq?
		    bnt code_0A64
		    lat temp3 
		    bnt code_0B70
		    pushi 164 // $A4 select
		    push2
		    push
		    push1
		    self 8

		    bnt code_0B70
		    lst temp3 
		    pToa helpIconItem
		    eq?
		    bnt code_0A54
		    pushi 36 // $24 cursor
		    push0
		    lat temp3 
		    send 4

		    bnt code_0A3E
		    pushi 183 // $B7 setCursor
		    push1
		    pushi 36 // $24 cursor
		    push0
		    lat temp3 
		    send 4

		    push
		    lag global_0001 
		    send 6

  code_0A3E:
		    pushi 17 // $11 signal
		    push1
		    pushi 17 // $11 signal
		    push0
		    pToa helpIconItem
		    send 4

		    push
		    ldi 16 // $10 lsRight
		    or
		    push
		    pToa helpIconItem
		    send 6

		    jmp code_0B70
  code_0A54:
		    pushi 17 // $11 signal
		    push0
		    lat temp3 
		    send 4

		    push
		    ldi 64 // $40 modifiers
		    and
		    sat temp4 
		    jmp code_0B70
  code_0A64:
		    dup
		    ldi 4 // $4 x
		    eq?
		    bnt code_0B12
		    lst temp2 
		    dup
		    ldi 27 // $1B elements
		    eq?
		    bnt code_0A7B
		    ldi 1 // $1 superClass
		    sat temp4 
		    jmp code_0B0E
  code_0A7B:
		    dup
		    ldi 13 // $D lsTop
		    eq?
		    bnt code_0AF0
		    lat temp3 
		    not
		    bnt code_0A8C
		    pToa highlightedIcon
		    sat temp3 
  code_0A8C:
		    lat temp3 
		    bnt code_0ACF
		    push
		    pToa helpIconItem
		    eq?
		    bnt code_0ACF
		    pushi 36 // $24 cursor
		    push0
		    lat temp3 
		    send 4

		    push
		    ldi -1 // $FFFF 
		    ne?
		    bnt code_0AB6
		    pushi 183 // $B7 setCursor
		    push1
		    pushi 36 // $24 cursor
		    push0
		    lat temp3 
		    send 4

		    push
		    lag global_0001 
		    send 6

  code_0AB6:
		    pToa helpIconItem
		    bnt code_0B0E
		    pushi 17 // $11 signal
		    push1
		    pushi 17 // $11 signal
		    push0
		    send 4

		    push
		    ldi 16 // $10 lsRight
		    or
		    push
		    pToa helpIconItem
		    send 6

		    jmp code_0B0E
  code_0ACF:
		    push1
		    lst temp3 
		    callk IsObject 2

		    bnt code_0B0E
		    pushi 164 // $A4 select
		    push1
		    lst temp3 
		    self 6

		    pushi 17 // $11 signal
		    push0
		    lat temp3 
		    send 4

		    push
		    ldi 64 // $40 modifiers
		    and
		    sat temp4 
		    jmp code_0B0E
  code_0AF0:
		    dup
		    ldi 3840 // $F00 
		    eq?
		    bnt code_0B01
		    pushi 174 // $AE retreat
		    push0
		    self 4

		    jmp code_0B0E
  code_0B01:
		    dup
		    ldi 9 // $9 nsTop
		    eq?
		    bnt code_0B0E
		    pushi 173 // $AD advance
		    push0
		    self 4

  code_0B0E:
		    toss
		    jmp code_0B70
  code_0B12:
		    dup
		    ldi 16384 // $4000 
		    eq?
		    bnt code_0B70
		    lst temp2 
		    ldi 6 // $6 loop
		    eq?
		    bnt code_0B70
		    lat temp3 
		    bnt code_0B4F
		    pushi 184 // $B8 helpStr
		    push0
		    send 4

		    bnt code_0B4F
		    push0
		    callk GetPort 0

		    sat temp5 
		    pushi 3 // $3 y
		    pushi 937 // $3A9 
		    push0
		    pushi 184 // $B8 helpStr
		    push0
		    lat temp3 
		    send 4

		    push
		    calle 255 public_255_0004 6
		    push1
		    lst temp5 
		    callk SetPort 2

  code_0B4F:
		    pToa helpIconItem
		    bnt code_0B65
		    pushi 17 // $11 signal
		    push1
		    pushi 17 // $11 signal
		    push0
		    send 4

		    push
		    ldi -17 // $FFEF 
		    and
		    push
		    pToa helpIconItem
		    send 6

  code_0B65:
		    pushi 183 // $B7 setCursor
		    push1
		    pushi 999 // $3E7 
		    lag global_0001 
		    send 6

  code_0B70:
		    toss
  code_0B71:
		    lat temp4 
		    ret
	)
	(method (disable) // method_0521
		(var temp0, temp1)
		    lap paramTotal 
		    bnt code_0589
		    ldi 0 // $0 species
		    sat temp0 
  code_052C:
		    lst temp0 
		    lap paramTotal 
		    lt?
		    bnt code_0590
		    push1
		    lat temp0 
		    lspi param1 
		    callk IsObject 2

		    bnt code_0546
		    lat temp0 
		    lapi param1 
		    jmp code_054F
  code_0546:
		    pushi 67 // $43 at
		    push1
		    lat temp0 
		    lspi param1 
		    self 6

  code_054F:
		    sat temp1 
		    pushi 17 // $11 signal
		    push1
		    pushi 17 // $11 signal
		    push0
		    send 4

		    push
		    ldi 4 // $4 x
		    or
		    push
		    lat temp1 
		    send 6

		    lst temp1 
		    pToa curIcon
		    eq?
		    bnt code_0573
		    pushi 195 // $C3 advanceCurIcon
		    push0
		    self 4

		    jmp code_0581
  code_0573:
		    lst temp1 
		    pToa highlightedIcon
		    eq?
		    bnt code_0581
		    pushi 173 // $AD advance
		    push0
		    self 4

  code_0581:
		    +at temp0 
		    jmp code_052C
		    jmp code_0590
  code_0589:
		    pTos state
		    ldi 4 // $4 x
		    or
		    aTop state
  code_0590:
		    ret
	)
	(method (enable) // method_0591
		(var temp0, temp1)
		    lap paramTotal 
		    bnt code_05DA
		    ldi 0 // $0 species
		    sat temp0 
  code_059C:
		    lst temp0 
		    lap paramTotal 
		    lt?
		    bnt code_05E1
		    push1
		    lat temp0 
		    lspi param1 
		    callk IsObject 2

		    bnt code_05B6
		    lat temp0 
		    lapi param1 
		    jmp code_05BF
  code_05B6:
		    pushi 67 // $43 at
		    push1
		    lat temp0 
		    lspi param1 
		    self 6

  code_05BF:
		    sat temp1 
		    pushi 17 // $11 signal
		    push1
		    pushi 17 // $11 signal
		    push0
		    send 4

		    push
		    ldi -5 // $FFFB 
		    and
		    push
		    lat temp1 
		    send 6

		    +at temp0 
		    jmp code_059C
		    jmp code_05E1
  code_05DA:
		    pTos state
		    ldi -5 // $FFFB 
		    and
		    aTop state
  code_05E1:
		    ret
	)*/
)
/******************************************************************************/
