/******************************************************************************/
(script 814)
/******************************************************************************/
(include "sci.sh")
/******************************************************************************/

(use "main")
(use "controls")
(use "iconbar")
(use "inv")
(use "obj")
(use "borderwnd")
/******************************************************************************/
(instance public invCode  of Code
	(method (init) // method_000E
		(var temp0)
		(Inv:
	      	init()
	      	add(
			    wallet
			    breathSpray
			    watch
			    apple
			    ring
			    whiskey
			    remoteControl
			    rose
			    lubber
			    candy
			    discoPass
			    pocketKnife
			    wine
			    magazine
			    hammer
			    pills
			    ribbon
			    graffiti
			    invLook
			    invHand
			    invSelect
			    invHelp
			    ok
			)
			eachElementDo(#highlightColor global_008E)
			eachElementDo(#lowlightColor global_008C)
			eachElementDo(#init)
			window(invWin)
			helpIconItem(invHelp)
			selectIcon(invSelect)
			okButton(ok)
		)
		(watch:owner(global[0]))
		(wallet:owner(global[0]))
		(breathSpray:owner(global[0]))
		
		
		(invWin:
			color(0)
			back(global_0094)
			topBordColor(global_0094)
			lftBordColor(global_0094)
			rgtBordColor(global_0094)
			botBordColor(global_0094)
			insideColor(global_008C)
			topBordColor2(global_0090)
			lftBordColor2(global_0090)
			botBordColor2(global_0091)
			rgtBordColor2(global_0091)
		)
	)
)

/******************************************************************************/
(instance invWin  of InsetWindow // $0166
	(properties
		top 0
		left 0
		bottom 0
		right 0
		color 0
		back 5
		priority 15
		window 0
		type 0
		title 0
		brTop 0
		brLeft 0
		brBottom 190
		brRight 320
		underBits 0
		pUnderBits 0
		topBordColor 5
		lftBordColor 4
		rgtBordColor 2
		botBordColor 1
		bevelWid 3
		shadowWid 2
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		ck 3
		insideColor 2
		topBordColor2 0
		lftBordColor2 1
		botBordColor2 5
		rgtBordColor2 4
		topBordHgt 28
		botBordHgt 5
		sideBordWid 2
		shadWid 0
		bevWid 2
		xOffset 0
		yOffset 0
	)
	(method (open)
		(invLook:nsLeft(- (/ (- (self:right) (self:left)) 2) 68))
		(super:open())
	)
)

/******************************************************************************/
(instance invLook  of IconI
	(properties
		view 851
		loop 2
		cel 0
		nsLeft 0
		nsTop 0
		nsRight 0
		nsBottom 0
		state 0
		cursor 101
		type 16384
		message 2
		modifiers 0
		signal 129
		helpStr "To look more closely at an object, first click here, then click on the item."
		maskView 0
		maskLoop 0
		maskCel 0
		highlightColor 0
		lowlightColor 0
	)
	(method (init)
  		(self:lowlightColor(global_0093))
  		(super:init())
	)
)

/******************************************************************************/
(instance invHand  of IconI
	(properties
		view 851
		loop 0
		cel 0
		nsLeft 0
		nsTop 65535
		nsRight 0
		nsBottom 0
		state 0
		cursor 102
		type 16384
		message 3
		modifiers 0
		signal 1
		helpStr "Use this when you want to do something to an item."
		maskView 0
		maskLoop 0
		maskCel 0
		highlightColor 0
		lowlightColor 0
	)
	(method (init)
  		(self:lowlightColor(global_008A))
  		(super:init())
	)
)

/******************************************************************************/
(instance invSelect  of IconI // $0290
	(properties
		view 851
		loop 4
		cel 0
		nsLeft 0
		nsTop 65535
		nsRight 0
		nsBottom 0
		state 0
		cursor 999
		type 16384
		message 65535
		modifiers 0
		signal 1
		helpStr "To use an item in the game, first click here, then click on the item, then click on OK." // String @ $0C0F
		maskView 0
		maskLoop 0
		maskCel 0
		highlightColor 0
		lowlightColor 0
	)
	(method (init)
  		(self:lowlightColor(global_0091))
  		(super:init())
	)
)

/******************************************************************************/
(instance invHelp  of IconI // $02E6
	(properties
		view 851
		loop 1
		cel 0
		nsLeft 0
		nsTop 65535
		nsRight 0
		nsBottom 0
		state 0
		cursor 150
		type 16384
		message 6
		modifiers 0
		signal 1
		helpStr "This icon tells you about other icons." // String @ $0C71
		maskView 0
		maskLoop 0
		maskCel 0
		highlightColor 0
		lowlightColor 0
	)

	(method (init)
  		(self:lowlightColor(global_0083))
  		(super:init())
	)
)

/******************************************************************************/
(instance ok  of IconI // $033C
	(properties
		view 851
		loop 3
		cel 0
		nsLeft 0
		nsTop 65535
		nsRight 0
		nsBottom 0
		state 0
		cursor 999
		type 16384
		message 65535
		modifiers 0
		signal 67
		helpStr "Click here to close this window and return to the game." // String @ $0CA0
		maskView 0
		maskLoop 0
		maskCel 0
		highlightColor 0
		lowlightColor 0
	)

	(method (init)
  		(self:lowlightColor(global_0087))
  		(super:init())
	)
)

/******************************************************************************/
(class LLinvItem of InvI // $042A
	(properties
		view 0
		loop 0
		cel 0
		nsLeft 0
		nsTop 0
		nsRight 0
		nsBottom 0
		state 0
		cursor 999
		type 16384
		message 4
		modifiers 0
		signal 2
		helpStr 0
		maskView 0
		maskLoop 0
		maskCel 0
		highlightColor 0
		lowlightColor 0
		description 0
		owner 0
		script 0
		value 0
	)
	(method (doVerb param1 param2)
		(switch(param1)
			(case 2
			    Print(
			    	(+ 850 (Inv:indexOf(self)))
			    	(Inv:indexOf(self))
			    	#icon 900 loop cel
			    )
			    UnLoad( rsTEXT (+ 850 (Inv:indexOf(self))) )
			)
			(case 3
				FormatPrint(814 0 (self:description))
			)
			(case 4
				(if(<> (Inv:indexOf(self)) param2)
		    		Print( (+ 850 param2) (Inv:indexOf(self)) )
		    	)(else
		    		Print(814 1)
		    	)
		    	UnLoad(rsTEXT (+ 850 param2))
			)
		)
	)
)

/******************************************************************************/
(instance wallet  of LLinvItem // $0574
	(properties
		view 900
		loop 0
		cel 0
		nsLeft 0
		nsTop 0
		nsRight 0
		nsBottom 0
		state 0
		cursor 0
		type 16384
		message 4
		modifiers 0
		signal 2
		helpStr 0
		maskView 0
		maskLoop 0
		maskCel 0
		highlightColor 0
		lowlightColor 0
		description "your wallet" // String @ $0CE5
		owner 0
		script 0
		value 0
	)/*
  (method (doVerb) // method_04A2
      (var temp0, temp1, temp2, temp3, temp4, temp5, temp6, temp7,
		     temp8, temp9, temp10, temps[91])
      (asm
		    lsp 1 /*param1*/ /*
		    dup
		    ldi 2 // $2 -info-
		    eq?
		    bnt code_04ED
		    lsg gRoomNumberExit 
		    ldi 250 // $FA syncNum
		    eq?
		    bt code_04BC
		    lsg gRoomNumberExit 
		    ldi 260 // $104 theVerb
		    eq?
  code_04BC:
		    bnt code_04CB
		    push2
		    pushi 814 // $32E 
		    push2
		    calle 255 Print 4
		    jmp code_0565
  code_04CB:
		    pushi 5 // $5 view
		    pushi 4 // $4 x
		    lea varTEMP 01
		    push
		    pushi 814 // $32E 
		    pushi 3 // $3 y
		    lsg global_009E 
		    callk Format 8

		    push
		    pushi 82 // $52 icon
		    pTos view
		    pTos loop
		    pTos cel
		    calle 255 Print 10
		    jmp code_0565
  code_04ED:
		    dup
		    ldi 3 // $3 y
		    eq?
		    bnt code_055A
		    pushi 15 // $F lsBottom
		    pushi 814 // $32E 
		    pushi 4 // $4 x
		    pushi 82 // $52 icon
		    pTos view
		    pTos loop
		    pTos cel
		    pushi 81 // $51 button
		    lofsa "Credit Cards" // String @ $0CF1  // $0CF1
		    push
		    push0
		    pushi 81 // $51 button
		    lofsa "Business Cards" // String @ $0CFE  // $0CFE
		    push
		    push1
		    pushi 81 // $51 button
		    lofsa "Notes" // String @ $0D0D  // $0D0D
		    push
		    push2
		    calle 255 Print 30
		    push
		    dup
		    ldi 0 // $0 species
		    eq?
		    bnt code_0531
		    push2
		    pushi 814 // $32E 
		    pushi 5 // $5 view
		    calle 255 Print 4
		    jmp code_0556
  code_0531:
		    dup
		    ldi 1 // $1 superClass
		    eq?
		    bnt code_0545
		    push2
		    pushi 814 // $32E 
		    pushi 6 // $6 loop
		    calle 255 Print 4
		    jmp code_0556
  code_0545:
		    dup
		    ldi 2 // $2 -info-
		    eq?
		    bnt code_0556
		    push2
		    pushi 814 // $32E 
		    pushi 7 // $7 cel
		    calle 255 Print 4
  code_0556:
		    toss
		    jmp code_0565
  code_055A:
		    pushi 263 // $107 doVerb
		    push2
		    lsp 1 /*param1*/ /*
		    lsp 2 /*param2*/ /*
		    super LLinvItem 8
  code_0565:
		    toss
		    ret
      )
  )*/
)

/******************************************************************************/
(instance breathSpray  of LLinvItem // $05BE
	(properties
		view 900
		loop 0
		cel 1
		nsLeft 0
		nsTop 0
		nsRight 0
		nsBottom 0
		state 0
		cursor 1
		type 16384
		message 4
		modifiers 0
		signal 2
		helpStr 0
		maskView 0
		maskLoop 0
		maskCel 0
		highlightColor 0
		lowlightColor 0
		description "your breath spray" // String @ $0D1A
		owner 0
		script 0
		value 0
	)
)

/******************************************************************************/
(instance watch  of LLinvItem // $0650
	(properties
		view 900
		loop 0
		cel 2
		nsLeft 0
		nsTop 0
		nsRight 0
		nsBottom 0
		state 0
		cursor 2
		type 16384
		message 4
		modifiers 0
		signal 2
		helpStr 0
		maskView 0
		maskLoop 0
		maskCel 0
		highlightColor 0
		lowlightColor 0
		description "your wrist watch" // String @ $0D38
		owner 0
		script 0
		value 0
	)
	(method (doVerb param1 param2) // method_05FC
		(var temps[100])
		(switch(param1)
			(case 2
				Print("test")/*
			    pushi 5 // $5 view
			    dup
			    lea varTEMP 00
			    push
			    pushi 814 // $32E 
			    pushi 8 // $8 underBits
			    lsg global_0099 
			    ldi 12 // $C nsRight
			    shr
			    push
			    lsg global_0099 
			    ldi 6 // $6 loop
			    shr
			    push
			    ldi 63 // $3F priority
			    and
			    push
			    callk Format 10
	
			    push
			    pushi 82 // $52 icon
			    pTos view
			    pTos loop
			    pTos cel
			    calle 255 Print 10
	  code_0633:*/
			)
			(default
				(super:doVerb(param1 param2))
			)
		)
	)
)

/******************************************************************************/
(instance apple  of LLinvItem // $069A
	(properties
		view 900
		loop 2
		cel 0
		nsLeft 0
		nsTop 0
		nsRight 0
		nsBottom 0
		state 0
		cursor 3
		type 16384
		message 4
		modifiers 0
		signal 2
		helpStr 0
		maskView 0
		maskLoop 0
		maskCel 0
		highlightColor 0
		lowlightColor 0
		description "the apple" // String @ $0D4F
		owner 300
		script 0
		value 0
	)
)

/******************************************************************************/
(instance ring  of LLinvItem // $06E0
	(properties
		view 900
		loop 2
		cel 1
		nsLeft 0
		nsTop 0
		nsRight 0
		nsBottom 0
		state 0
		cursor 4
		type 16384
		message 4
		modifiers 0
		signal 2
		helpStr 0
		maskView 0
		maskLoop 0
		maskCel 0
		highlightColor 0
		lowlightColor 0
		description "the diamond ring" // String @ $0D5F
		owner 130
		script 0
		value 0
	)
)

/******************************************************************************/
(instance whiskey  of LLinvItem // $0726
	(properties
		view 900
		loop 2
		cel 2
		nsLeft 0
		nsTop 0
		nsRight 0
		nsBottom 0
		state 0
		cursor 5
		type 16384
		message 4
		modifiers 0
		signal 2
		helpStr 0
		maskView 0
		maskLoop 0
		maskCel 0
		highlightColor 0
		lowlightColor 0
		description "your glass of whiskey" // String @ $0D75
		owner 110
		script 0
		value 0
	)
)

/******************************************************************************/
(instance remoteControl  of LLinvItem // $079E
	(properties
		view 900
		loop 2
		cel 3
		nsLeft 0
		nsTop 0
		nsRight 0
		nsBottom 0
		state 0
		cursor 6
		type 16384
		message 4
		modifiers 0
		signal 2
		helpStr 0
		maskView 0
		maskLoop 0
		maskCel 0
		highlightColor 0
		lowlightColor 0
		description "your remote control" // String @ $0D93
		owner 120
		script 0
		value 0
	)
  (method (doVerb) // method_0764
      (asm
		    lsp 1 /*param1*/ 
		    dup
		    ldi 3 // $3 y
		    eq?
		    bnt code_0784
		    push2
		    pushi 814 // $32E 
		    pushi 9 // $9 nsTop
		    calle 255 Print 4
		    push2
		    pushi 814 // $32E 
		    pushi 10 // $A nsLeft
		    calle 255 Print 4
		    jmp code_078F
  code_0784:
		    pushi 263 // $107 doVerb
		    push2
		    lsp 1 /*param1*/ 
		    lsp 2 /*param2*/ 
		    super LLinvItem 8
  code_078F:
		    toss
		    ret
      )
  )
)

/******************************************************************************/
(instance rose  of LLinvItem // $07E8
	(properties
		view 900
		loop 2
		cel 4
		nsLeft 0
		nsTop 0
		nsRight 0
		nsBottom 0
		state 0
		cursor 7
		type 16384
		message 4
		modifiers 0
		signal 2
		helpStr 0
		maskView 0
		maskLoop 0
		maskCel 0
		highlightColor 0
		lowlightColor 0
		description "the rose" // String @ $0DB5
		owner 120
		script 0
		value 0
	)
)

/******************************************************************************/
(instance lubber  of LLinvItem // $082E
	(properties
		view 900
		loop 2
		cel 5
		nsLeft 0
		nsTop 0
		nsRight 0
		nsBottom 0
		state 0
		cursor 8
		type 16384
		message 4
		modifiers 0
		signal 2
		helpStr 0
		maskView 0
		maskLoop 0
		maskCel 0
		highlightColor 0
		lowlightColor 0
		description "your prophylactic" // String @ $0DC3
		owner 510
		script 0
		value 0
	)
)

/******************************************************************************/
(instance candy  of LLinvItem // $0874
	(properties
		view 900
		loop 2
		cel 6
		nsLeft 0
		nsTop 0
		nsRight 0
		nsBottom 0
		state 0
		cursor 9
		type 16384
		message 4
		modifiers 0
		signal 2
		helpStr 0
		maskView 0
		maskLoop 0
		maskCel 0
		highlightColor 0
		lowlightColor 0
		description "the box of candy" // String @ $0DDC
		owner 150
		script 0
		value 0
	)
)

/******************************************************************************/
(instance discoPass  of LLinvItem // $08EE
	(properties
		view 900
		loop 2
		cel 7
		nsLeft 0
		nsTop 0
		nsRight 0
		nsBottom 0
		state 0
		cursor 10
		type 16384
		message 4
		modifiers 0
		signal 2
		helpStr 0
		maskView 0
		maskLoop 0
		maskCel 0
		highlightColor 0
		lowlightColor 0
		description "the disco pass" // String @ $0DF3
		owner 330
		script 0
		value 0
	)
  (method (doVerb) // method_08B2
      (asm
  code_08B2:
		    lsp 1 /*param1*/ 
		    dup
		    ldi 2 // $2 -info-
		    eq?
		    bnt code_08D4
		    pushi 8 // $8 underBits
		    pushi 814 // $32E 
		    pushi 11 // $B nsBottom
		    pushi 30 // $1E mode
		    push1
		    pushi 82 // $52 icon
		    pTos view
		    pTos loop
		    pTos cel
		    calle 255 Print 16
		    jmp code_08DF
  code_08D4:
		    pushi 263 // $107 doVerb
		    push2
		    lsp 1 /*param1*/ 
		    lsp 2 /*param2*/ 
		    super LLinvItem 8
  code_08DF:
		    toss
		    ret
      )
  )
)

/******************************************************************************/
(instance pocketKnife  of LLinvItem // $0938
	(properties
		view 900
		loop 2
		cel 8
		nsLeft 0
		nsTop 0
		nsRight 0
		nsBottom 0
		state 0
		cursor 11
		type 16384
		message 4
		modifiers 0
		signal 2
		helpStr 0
		maskView 0
		maskLoop 0
		maskCel 0
		highlightColor 0
		lowlightColor 0
		description "your pocketknife" // String @ $0E0C
		owner 500
		script 0
		value 0
	)
)

/******************************************************************************/
(instance wine  of LLinvItem // $097E
	(properties
		view 900
		loop 2
		cel 9
		nsLeft 0
		nsTop 0
		nsRight 0
		nsBottom 0
		state 0
		cursor 12
		type 16384
		message 4
		modifiers 0
		signal 2
		helpStr 0
		maskView 0
		maskLoop 0
		maskCel 0
		highlightColor 0
		lowlightColor 0
		description "your wine" // String @ $0E29
		owner 510
		script 0
		value 0
	)
)

/******************************************************************************/
(instance magazine  of LLinvItem // $0A16
	(properties
		view 900
		loop 2
		cel 10
		nsLeft 0
		nsTop 0
		nsRight 0
		nsBottom 0
		state 0
		cursor 13
		type 16384
		message 4
		modifiers 0
		signal 2
		helpStr 0
		maskView 0
		maskLoop 0
		maskCel 0
		highlightColor 0
		lowlightColor 0
		description "your magazine" // String @ $0E38
		owner 510
		script 0
		value 0
	)
  (method (doVerb) // method_09BC
      (asm
		    lsp 1 /*param1*/ 
		    ldi 2 // $2 -info-
		    eq?
		    bt code_09C9
		    lsp 1 /*param1*/ 
		    ldi 3 // $3 y
  code_09C8:
		    eq?
  code_09C9:
		    bnt code_09FD
		    push2
		    pushi 814 // $32E 
		    pushi 12 // $C nsRight
		    calle 255 Print 4
		    push2
		    pushi 814 // $32E 
		    pushi 13 // $D lsTop
		    calle 255 Print 4
		    push2
		    pushi 85 // $55 z
		    push1
		    callb proc000_11 4
		    pushi 6 // $6 loop
		    pushi 814 // $32E 
		    pushi 14 // $E lsLeft
		    pushi 82 // $52 icon
		    pTos view
		    pTos loop
		    pushi 15 // $F lsBottom
		    calle 255 Print 12
		    jmp code_0A08
  code_09FD:
		    pushi 263 // $107 doVerb
		    push2
		    lsp 1 /*param1*/ 
		    lsp 2 /*param2*/ 
		    super LLinvItem 8
  code_0A08:
		    ret
      )
  )
)

/******************************************************************************/
(instance hammer  of LLinvItem // $0A60
	(properties
		view 900
		loop 2
		cel 11
		nsLeft 0
		nsTop 0
		nsRight 0
		nsBottom 0
		state 0
		cursor 14
		type 16384
		message 4
		modifiers 0
		signal 2
		helpStr 0
		maskView 0
		maskLoop 0
		maskCel 0
		highlightColor 0
		lowlightColor 0
		description "Lefty's hammer" // String @ $0E4F
		owner 160
		script 0
		value 0
	)
)

/******************************************************************************/
(instance pills  of LLinvItem // $0AA6
	(properties
		view 900
		loop 2
		cel 12
		nsLeft 0
		nsTop 0
		nsRight 0
		nsBottom 0
		state 0
		cursor 15
		type 16384
		message 4
		modifiers 0
		signal 2
		helpStr 0
		maskView 0
		maskLoop 0
		maskCel 0
		highlightColor 0
		lowlightColor 0
		description "the bottle of pills" // String @ $0E65
		owner 160
		script 0
		value 0
	)
)

/******************************************************************************/
(instance ribbon  of LLinvItem // $0AEC
	(properties
		view 900
		loop 2
		cel 13
		nsLeft 0
		nsTop 0
		nsRight 0
		nsBottom 0
		state 0
		cursor 16
		type 16384
		message 4
		modifiers 0
		signal 2
		helpStr 0
		maskView 0
		maskLoop 0
		maskCel 0
		highlightColor 0
		lowlightColor 0
		description "the ribbon" // String @ $0E7F
		owner 390
		script 0
		value 0
	)
)

/******************************************************************************/
(instance graffiti  of LLinvItem // $0B32
	(properties
		view 900
		loop 2
		cel 14
		nsLeft 0
		nsTop 0
		nsRight 0
		nsBottom 0
		state 0
		cursor 17
		type 16384
		message 4
		modifiers 0
		signal 2
		helpStr 0
		maskView 0
		maskLoop 0
		maskCel 0
		highlightColor 0
		lowlightColor 0
		description "the password" // String @ $0E91
		owner 130
		script 0
		value 0
	)
)

/******************************************************************************/
