/******************************************************************************/
(script 996)
/******************************************************************************/
(include "sci.sh")
/******************************************************************************/

(use "main")
(use "polypath")
(use "cycle")
(use "features")
(use "obj")

/******************************************************************************/
(local
	local_0000[24]
	local_0017
)
/******************************************************************************/

/*string
  string_06B0 "uEvt"
  string_06B5 "Enter input"
  string_06C1 "User"
  string_06C6 "Ego"
  string_06CA "OnMeAndLowY"
*/
(instance uEvt  of Event // $000C
	(properties)
)

/******************************************************************************/
(class User of Obj // $02A4
	(properties
		alterEgo 0
		input 0
		controls 0
		echo 32
		prevDir 0
		prompt "Enter input" // String @ $06B5
		inputLineAddr 0
		x -1
		y -1
		mapKeyToDir 1
		curEvent 0
		verbMessager 0
	)
	(method (init param1 param2) // method_002A
		= inputLineAddr
			(if(paramTotal)
				param1
			)(else
				@local_0000
			)
		= local_0017
			(if(== paramTotal 2)
				param2
			)(else
				45
			)
		= curEvent uEvt
	)
	(method (doit) // method_005C
		(send curEvent:
			type(0)
			message(0)
			modifiers(0)
			y(0)
			x(0)
			claimed(FALSE)
			port(NULL)
		)
		
		GetEvent(evALL_EVENTS curEvent)
		
		(self:handleEvent(curEvent))
	)
	(method (canControl param1)
		(if(paramTotal)
			= controls param1
			= prevDir CENTER /* 0--no direction*/
		)
		return(controls)
	)
	(method (getInput))
	(method (said))
	(method (handleEvent pEvent)
		(var temp0, temp1)
      
		= global_0046 (send pEvent:x)
		= global_0047 (send pEvent:y)
	
		(if(send pEvent:type)
			= global_0018 1 
      
      		(if(mapKeyToDir)
      			MapKeyToDir(pEvent)
      		)
      		(if(== (send pEvent:type) $100)		    	
				(send pEvent:
					type(evKEYBOARD)
					message(
					    (if(& (send pEvent:modifiers) 3)
					    	KEY_ESCAPE
					    )(else
					    	KEY_RETURN
					    )
					)
					modifiers(0)
				)
			)
			= temp0 (send pEvent:type)
			
			(if(global_0044)
				(send temp0:handleEvent(pEvent))
			)
			
			(send pEvent:localize())
			
			(if(& (send pEvent:type) $40)
			    (if(
				    (if (global_004D)
				    	(send global_004D:handleEvent(pEvent))
				    )
				    or
				    (if (global_004A)
				    	(send global_004A:handleEvent(pEvent))
				    )
				    or
				    (if ((alterEgo) and (controls))
				    	(send alterEgo:handleEvent(pEvent))
					)
				    or
				    (if (global_0045)
				    	(send global_0045:handleEvent(pEvent))
				    )
				   )
				   // continue
				)
			)(else
				(if(== temp0 4)
					(if(global_0048)
						(send global_0048:handleEvent(pEvent))
					)
				)(else
					(if( (== temp0 1) and global_0049 )
						(send global_0049:handleEvent(pEvent))
					)
				)
			)
		)
		(if(not (send pEvent:claimed))
		    (if(global_0045)
		    	(send global_0045:handleEvent(pEvent))
		    )
		    (if((== (send pEvent:type) $4000) and (input))
			    (if((== (send pEvent:message) 1) and controls 
			      and (send alterEgo:handleEvent(pEvent)))
			    		(1)
				)(else
					(if(global_0022)
						(OnMeAndLowY:init())
						
						(send gCast:
							eachElementDo(
								#perform OnMeAndLowY pEvent
							)
						)
						(send global_0020:
							eachElementDo(
								#perform OnMeAndLowY pEvent
							)
						)
			
						(if(OnMeAndLowY:theObj)	
					    	(send (OnMeAndLowY:theObj):handleEvent(pEvent))
					   	)
					)(else
						(if(send gCast:handleEvent(pEvent))
					    	(1)
					    )(else
					    	(if(send global_0020:handleEvent(pEvent))
					    		(1)
					    	)
					    )
					)
				)
				
				(if(send pEvent:claimed)
					(TRUE)
				)(else
					(if(send gRegions:handleEvent(pEvent))
						(TRUE)
					)
				)
			)
			(if( (send pEvent:type) and not(send pEvent:claimed) )
				(send gGame:handleEvent(pEvent))
			)
		)
	)
	(method (canInput param1)
		(if(paramTotal)
			= input param1
		)
		return(input)
	)
)

/******************************************************************************/
(class Ego of Actor // $054C
	(properties
		x 0
		y 0
		z 0
		heading 0
		noun 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		description 0
		sightAngle 26505
		actions 0
		onMeCheck 26505
		approachX 0
		approachY 0
		approachDist 0
		_approachVerbs 26505
		lookStr 0
		yStep 2
		view 0
		loop 0
		cel 0
		priority 0
		underBits 0
		signal 8192
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		palette 0
		cycleSpeed 0
		script 0
		cycler 0
		timer 0
		detailLevel 0
		illegalBits 32768
		xLast 0
		yLast 0
		xStep 3
		moveSpeed 0
		blocks 0
		baseSetter 0
		mover 0
		looper 0
		viewer 0
		avoider 0
		code 0
		edgeHit 0
	)
	(method (init)
		(super:init())
		(if(not cycler)
			(self:setCycle(Walk))
		)
	)
	(method (doit)
		(super:doit())
		= edgeHit 
			(if(<= x 0)
				EDGE_LEFT
			)(else
				(if(>= x 319)
					EDGE_RIGHT
				)(else
					(if(>= y 189)
						EDGE_BOTTOM
					)(else
						(if(<= y (send gRoom:horizon))
							EDGE_TOP
						)(else
							EDGE_NONE
						)
					)
				)
			)	
	)
	(method (handleEvent pEvent)
		(var temp0)
		
		(if (script)
			(send script:handleEvent(pEvent))
		)
		(if( (send pEvent:claimed) or not (send gCast:contains(self)) )
			(TRUE)
		)(else
      		(if((& (send pEvent:type) $40) and (send global_0050:controls))
			    (if((== (= temp0 (send pEvent:message)) 0) and (& (send pEvent:type) 4))
			    	return(send pEvent:claimed)
				)
	  
	  			(if( (== temp0 (send global_0050:prevDir)) and IsObject(mover) )
			    	= temp0 0
				)
				
				(send global_0050:prevDir(temp0))
				(self:setDirection(temp0))
				(send pEvent:claimed(TRUE))
			)(else
	  			(if((== (send pEvent:type) $4000) or (== (send pEvent:type) 1))
				    (if(
				    	(if ( (== (send pEvent:message) 1) or (== (send pEvent:type) 1) ))
				    	and
				    	(send global_0050:controls)
				       )
				    
						    (self:
						    	setMotion(
								    (if(global_0043)
								    	PolyPath
								    )(else
								    	MoveTo
								    )
								    (send pEvent:x)
								    (send pEvent:y)
								)
							)
							
							(send global_0050:prevDir(0))
							(send pEvent:claimed(TRUE))
					)(else
		  				(super:handleEvent(pEvent))
		  			)
				)(else 
	  				(super:handleEvent(pEvent))
	  			)
			)
		)
  		(send pEvent:claimed)
	)
	(method (get items)
		(var i, invItem)
		(for (= i 0) (< i paramTotal) (++i)
			= invItem (send gInv:at(items[i]))
			(send invItem:moveTo(self))
		 )
	)
	(method (put item newOwner)
		(var invItem)
		(if( (self:has(item)) )
			= invItem (send gInv:at(item))
		    (if(== paramTotal 1)
				(send invItem:moveTo(-1))
			)(else
				(send invItem:moveTo(newOwner))
			)
			(if(global_0045 and (== (send global_0045:curInvIcon) invItem) )
				(send global_0045:
					curInvIcon(NULL)
					disable(
					    (send (send global_0045:useIconItem):
					    	cursor(999)
					    	yourself()
					    )
					)
				)
			)
		)
	)
	(method (has item)
		(var invItem)
		= invItem (send gInv:at(item))
		(if(invItem)
			(send invItem:ownedBy(self))
		)
	)
)

/******************************************************************************/
(class OnMeAndLowY of Code
	(properties
		theObj 0
		lastY -1
	)
	(method (init)
		= theObj NULL
		= lastY -1
	)
	(method (doit param1 param2)
		(if( (send param1:onMe(param2)) and (> (send param1:y) lastY) )
		    = theObj param1		    
		    = lastY (send theObj:y)
		)
	)
)

/******************************************************************************/
