/******************************************************************************/
(script 995)
/******************************************************************************/
(include "sci.sh")
/******************************************************************************/
(use "main")
(use "controls")
(use "iconbar")
(use "window")
(use "obj")
/******************************************************************************/
(class InvI of IconI
	(properties
		view 0
		loop 0
		cel 0
		nsLeft 0
		nsTop 0
		nsRight 0
		nsBottom 0
		state 0
		cursor 999
		type $4000
		message 4
		modifiers 0
		signal 0
		helpStr 0
		maskView 0
		maskLoop 0
		maskCel 0
		highlightColor 0
		lowlightColor 0
		description 0
		owner 0
		script 0
		value 0
	)
	(method (show)
		(var temp0[4])
		DrawCel(view loop cel nsLeft nsTop -1)
	)
	(method (highlight param1)
		(var temp0, temp1, temp2, temp3, temp4)
		
		= temp4 (if(paramTotal and param1)
		    highlightColor
		)(else
		    lowlightColor
		)
		= temp0 (- nsTop 2)
		= temp1 (- nsLeft 2)
		= temp2 (+ nsBottom 1)
		= temp3 (+ nsRight 1)
		
		Graph(4 temp0 temp1 temp0 temp3 temp3 -1 -1)
		Graph(4 temp0 temp3 temp2 temp3 temp4 -1 -1)
		Graph(4 temp2 temp3 temp2 temp1 temp4 -1 -1)
		Graph(4 temp2 temp1 temp0 temp1 temp4 -1 -1)
		
		Graph(
			12
			(- nsTop 2)
			(- nsLeft 2)
			(+ nsBottom 2)
			(+ nsRight 2)
			1
		)
	)
	(method (onMe param1)
		return(if(super:onMe(param1))
			not(& signal 4)
		)
	)
	(method (ownedBy param1)
		return(if(== owner param1))
	)
	(method (moveTo param1)
		= owner param1
		(if((value) and (= param1 global[0]))
			(send gGame:changeScore(value))
			= value 0
		)
		return(self)
	)
	(method (doVerb param1)
		(switch(param1)
			(case 2
				FormatPrint("%s" description)
			)
		)
	)
)
/******************************************************************************/
(class Inv of IconBar
	(properties
		elements 0
		size 0
		height 0
		underBits 0
		oldMouseX 0
		oldMouseY 0
		curIcon 0
		highlightedIcon 0
		prevIcon 0
		curInvIcon 0
		useIconItem 0
		helpIconItem 0
		port 0
		window 0
		state 0
		activateHeight 0
		y 0
		normalHeading "Roger is carrying:"
		heading 0
		empty "nothing!"
		curScore "Score: %d out of %d"
		showScore 1
		iconBarInvItem 0
		okButton 0
		selectIcon 0
	)
	(method (init)
		= gInv self
		= heading normalHeading
	)
	(method (doit)
		(var temp0, temp1, temp2, temp3, temp4, temp5, temp6, temp7)
  code_081B:
  			(= temp1 (Event:new())
		    bnt code_0B56
		    (& state $20)
		    bnt code_0B56
		    = temp7 0
		    (send temp1:localize()
		    (curIcon)
		    bnt code_08C5
		    (not (send temp1:modifiers))
		    bnt code_08C5
		    (<> curIcon selectIcon)
		    bnt code_08C5
		    (== (send temp1:type) 1)
		    bt code_0897
		    (== (send temp1:type) 4)
		    bnt code_0881
		    (== (send temp1:message) KEY_ENTER)
		    bnt code_0881
		    (= temp7 1)
  code_0881:
		    bt code_0897
		    (== (send temp1:type) $100)
		    bnt code_08C5
		    (= temp7 1)
  code_0897:
		    bnt code_08C5
		    (<> curIcon helpIconItem)
		    bt code_08AD
		    (& (send helpIconItem:signal) $10)
  code_08AD:
		    bnt code_08C5
		    (send temp1:
		    	type($4000)
		    	message(send curIcon:message)
			)
  code_08C5:
		    MapKeyToDir(temp1)
		    (== (= temp2 (send temp1:type)) 1)
		    bnt code_08F6
		    (send temp1:modifiers)
		    bnt code_08F6
		    (self:advanceCurIcon())
		    (send temp1:claimed(TRUE))
		    jmp code_0B4C
  code_08F6:
  			(== temp2 0)
		    bnt code_091F
		    = temp0 (self:firstTrue(#onMe temp1))
		    bnt code_091F
			(<> temp0 highlightedIcon)
		    bnt code_091F
		    (self:highlight(temp0))
		    jmp code_0B4C
  code_091F:
  			(== temp2 1)
		    bt code_0943
		    (== temp2 4)
		    bnt code_093A
		    (== (send temp1:message) KEY_RETURN))
  code_093A:
		    bt code_0943
		    (== temp2 $100)
  code_0943:
		    bnt code_09C5
		    IsObject(highlightedIcon)
		    bnt code_0B4C
		    (self:select(
		    	highlightedIcon
		    	(== temp2 1)
		    ))
		    bnt code_0B4C
		    (== highlightedIcon okButton)
		    bnt code_096E
		    jmp code_0B56
		    jmp code_0B4C
  code_096E:
  			(== highlightedIcon helpIconItem)
		    bnt code_09AD
		    (<> (send highlightedIcon:cursor) -1)
		    bnt code_0994
		    (send gGame:setCursor(
		    	(send helpIconItem:cursor)
		    ))
  code_0994:
		    (helpIconItem)
		    bnt code_0B4C
		    (send helpIconItem:signal(| (send helpIconItem:signal) $10)
		    jmp code_0B4C
  code_09AD:
		    = curIcon highlightedIcon
		    (send gGame:setCursor( (send curIcon:cursor) TRUE))
		    jmp code_0B4C
  code_09C5:
  
  
  			(& temp2 $40)
		    bnt code_0A32
		    (send temp1:message)
		    push
		    dup
		    ldi 3 // $3 y
		    eq?
		    bnt code_09E5
		    (self:advance())
		    jmp code_0A2E
  code_09E5:
		    dup
		    ldi 7 // $7 cel
		    eq?
		    bnt code_09F5
		    (self:retreat())
		    jmp code_0A2E
  code_09F5:
		    dup
		    ldi 1 // $1 superClass
		    eq?
		    bnt code_0A07
		    (self:retreat(local_0000))
		    jmp code_0A2E
  code_0A07:
		    dup
		    ldi 5 // $5 view
		    eq?
		    bnt code_0A19
		    (self:advance(local_0000))
		    jmp code_0A2E
  code_0A19:
		    dup
		    ldi 0 // $0 species
		    eq?
		    bnt code_0A2E
		    (& temp2 4)
		    bnt code_0A2E
		    (self:advanceCurIcon())
  code_0A2E:
		    toss
		    
		    
		    
		    
		    jmp code_0B4C
  code_0A32:
		    lst temp2 
		    ldi 4 // $4 x
		    eq?
		    bnt code_0A64
		    (send temp1:message)
		    push
		    dup
		    ldi 9 // $9 nsTop
		    eq?
		    bnt code_0A52
		    (self:advance)
		    jmp code_0A60
  code_0A52:
		    dup
		    ldi 3840 // $F00 
		    eq?
		    bnt code_0A60
		    (self:retreat)
  code_0A60:
		    toss
		    jmp code_0B4C
  code_0A64:
		    lst temp2 
		    ldi 16384 // $4000 
		    eq?
		    bnt code_0B4C
		    (= temp0 (self:firstTrue(#onMe temp1)))
		    bnt code_0B4C
		    (send temp1:message)
		    push
		    ldi 6 // $6 loop
		    eq?
		    bnt code_0ACC
		    (temp0)
		    bnt code_0AAB
		    (send temp0:helpStr)
		    bnt code_0AAB
		    Format("%s" (send temp0:helpStr))
  code_0AAB:
		    (send helpIconItem:signal(& (send helpIconItem:signal) $FFEF)
			(send gGame:setCursor(999))
		    jmp code_0B4C
  code_0ACC:
		    (== temp0 okButton) 
		    bnt code_0ADA
		    jmp code_0B56
		    jmp code_0B4C
  code_0ADA:
  			(not (send temp0:isKindOf(InvI)))
		    bnt code_0B0F
		    (self:select(temp0 not(temp7)))
		    bnt code_0B4C
		    (= curIcon temp0)
		    (send gGame:
		    	setCursor(
		    		(send CurIcon:cursor)
		    		TRUE
		    	)
		    )
		    jmp code_0B4C
  code_0B0F:
		    (curIcon)
		    bnt code_0B4C
		    (send curIcon:isKindOf(InvI))
		    bnt code_0B3C
		    (send temp0:
		    	doVerb(
		    		(send curIcon:message)
		    		(self:indexOf(curIcon))
		    	)
		   	)
		    jmp code_0B4C
  code_0B3C:
  			(send temp0:doVerb(send temp1:message))
  code_0B4C:
  			(send temp1:dispose())
		    jmp code_081B
  code_0B56:
  			(send temp1:dispose())
  			(self:hide())
	)
	(method (showSelf param1)
		(send global[8]:pause())
		(if(global[$4D] and (send global[$4D]:respondsTo(#stop)))
			(send global[$4D]:stop())
		)
		(if(send global[$45]:height)
			(send global[$45]:hide())
		)
		(if(not window)
			= window (SysWindow:new())
		)
		(if(send window:window)
			(send window:dispose())
			= window NULL
		)
		(if(not okButton)
			= okButton NodeValue(self:first)
		)
		= curIcon NULL
		(send gGame:setCursor(send selectIcon:cursor))
		(self:
			show(
				(if(paramTotal)
					param1
				)(else
				global[0]
				)
			)
			doit()
		)
	)
	(method (show param1)
		= state (| state $20)
		
		proc_01A2(
			(if(paramTotal)
				param1
			)(else
				global[0]
			)
			(send global[$45]:curIcon)
		)
	)
	(method (hide)
		(if(& state $20)
			(send global[8]:pause())
			= state (& state $FFDF)
		)
		(if(window)
			(send window:dispose())
		)
		(if(IsObject(curIcon) and (send curIcon:isKindOf(InvI)))
			(if(not (send global[$45]:curInvIcon))
				(send global[$45]:enable(
					(send global[$45]:useIconItem)
				))
			)
			(send global[$45]:
				curIcon(
		    		(send (send global[$45]:useIconItem):
		    			cursor(send curIcon:cursor)		
		    			yourself()
		    		)
		    	)
		    	curInvIcon(curIcon)
		    )
		    (if(send curIcon:cursor)
		    	(send gGame:setCursor(
		    		(send curIcon:cursor)
		    		TRUE
		    	))
		    )
		)
	)
	(method (advance param1)
		(var temp0, temp1, temp2, temp3)
		= temp1 
			(if(paramTotal)
				param1
			)(else
				1
			)
		= temp2 (self:indexOf(highlightedIcon))
		= temp3 (+ temp2 temp1)
		(while(1)
  			= temp0 (self:at(
		    	(if(<= temp3 size)
		    		temp3
		    	)(else
  					(% temp3 (- size 1))
  				)
  			))
  			(if(not IsObject(temp0))
  				= temp0 NodeValue(self:first)
			)
			(if(not (& (send temp0:signal) 4))
				break
			)
			++temp3
		)
  		(send gGame:
  			setCursor(
  				gNormalCursor
  				TRUE
  				(+ (send temp0:nsLeft) (/ (- (send temp0:nsRight) (send temp0:nsLeft)) 2))
  				(- (send temp0:nsBottom) 3)
  			)
  		)
  		(self:highlight(temp0))
	)
	(method (retreat param1)
		(var temp0, temp1, temp2, temp3)
		= temp1 
			(if(paramTotal)
				param1
			)(else
				1
			)
		= temp2 (self:indexOf(highlightedIcon))
		= temp3 (- temp2 temp1)
		(while(1)
  			= temp0 (self:at(temp3))
  			(if(not IsObject(temp0))
  				= temp0 NodeValue(self:last)
			)
			(if(not (& (send temp0:signal) 4))
				break
			)
			--temp3
		)
  		(send gGame:
  			setCursor(
  				gNormalCursor
  				TRUE
  				(+ (send temp0:nsLeft) (/ (- (send temp0:nsRight) (send temp0:nsLeft)) 2))
  				(- (send temp0:nsBottom) 3)
  			)
  		)
  		(self:highlight(temp0))
	)
	(method (advanceCurIcon)
		(var temp0)
		= temp0 curIcon
		(while(send (= temp0 (self:at(% (+ (self:indexOf(temp0)) 1) size))):isKindOf(InvI)))
		= curIcon temp0
		(send gGame:setCursor((send curIcon:cursor) TRUE))
	)
	(method (ownedBy param1)
		(self:firstTrue(#ownedBy param1))
	)
)
/******************************************************************************/
(procedure (proc_01A2)/*
		(var temp0, temp1, temp2, temp3, temp4, temp5, temp6, temp7,
		     temp8, temp9, temp10, temps[11])
		    ldi 0 // $0 species
		    sat temp5 
		    sat temp4 
		    sat temp3 
		    sat temp2 
		    sat temp1 
		    sat temp0 
		    pushi 118 // $76 first
		    push0
		    lag global_0009 
		    send 4

		    sat temp8 
  code_01BB:
		    lat temp8 
		    bnt code_02BE
		    pushi 108 // $6C isKindOf
		    push1
		    class InvI
		    push
		    push1
		    lst temp8 
		    callk NodeValue 2

		    sat temp9 
		    send 6

		    bnt code_0262
		    pushi 324 // $144 ownedBy
		    push1
		    lsp param1 
		    lat temp9 
		    send 6

		    bnt code_024C
		    pushi 17 // $11 signal
		    push1
		    pushi 17 // $11 signal
		    push0
		    lat temp9 
		    send 4

		    push
		    ldi -5 // $FFFB 
		    and
		    push
		    lat temp9 
		    send 6

		    +at temp0 
		    pushi 3 // $3 y
		    pushi 5 // $5 view
		    push0
		    lat temp9 
		    send 4

		    push
		    pushi 6 // $6 loop
		    push0
		    lat temp9 
		    send 4

		    push
		    pushi 7 // $7 cel
		    push0
		    lat temp9 
		    send 4

		    push
		    callk CelWide 6

		    sat temp6 
		    push
		    lat temp2 
		    gt?
		    bnt code_021F
		    lat temp6 
		    sat temp2 
  code_021F:
		    pushi 3 // $3 y
		    pushi 5 // $5 view
		    push0
		    lat temp9 
		    send 4

		    push
		    pushi 6 // $6 loop
		    push0
		    lat temp9 
		    send 4

		    push
		    pushi 7 // $7 cel
		    push0
		    lat temp9 
		    send 4

		    push
		    callk CelHigh 6

		    sat temp7 
		    push
		    lat temp1 
		    gt?
		    bnt code_02B0
		    lat temp7 
		    sat temp1 
		    jmp code_02B0
  code_024C:
		    pushi 17 // $11 signal
		    push1
		    pushi 17 // $11 signal
		    push0
		    lat temp9 
		    send 4

		    push
		    ldi 4 // $4 x
		    or
		    push
		    lat temp9 
		    send 6

		    jmp code_02B0
  code_0262:
		    +at temp3 
		    lst temp5 
		    pushi 3 // $3 y
		    pushi 5 // $5 view
		    push0
		    lat temp9 
		    send 4

		    push
		    pushi 6 // $6 loop
		    push0
		    lat temp9 
		    send 4

		    push
		    pushi 7 // $7 cel
		    push0
		    lat temp9 
		    send 4

		    push
		    callk CelWide 6

		    add
		    sat temp5 
		    pushi 3 // $3 y
		    pushi 5 // $5 view
		    push0
		    lat temp9 
		    send 4

		    push
		    pushi 6 // $6 loop
		    push0
		    lat temp9 
		    send 4

		    push
		    pushi 7 // $7 cel
		    push0
		    lat temp9 
		    send 4

		    push
		    callk CelHigh 6

		    sat temp7 
		    push
		    lat temp4 
		    gt?
		    bnt code_02B0
		    lat temp7 
		    sat temp4 
  code_02B0:
		    pushi 68 // $44 next
		    push1
		    lst temp8 
		    lag global_0009 
		    send 6

		    sat temp8 
		    jmp code_01BB
  code_02BE:
		    lat temp0 
		    not
		    bnt code_02D3
		    pushi 4 // $4 x
		    pushi 995 // $3E3 
		    push1
		    pTos property[17]
		    pTos property[19]
		    calle 255 public_255_0004 8
		    ret
  code_02D3:
		    push1
		    lst temp0 
		    callk Sqrt 2

		    sat temp16 
		    push
		    mul
		    push
		    lat temp0 
		    gt?
		    bnt code_02E6
		    -at temp16 
  code_02E6:
		    lst temp16 
		    ldi 3 // $3 y
		    gt?
		    bnt code_02F2
		    ldi 3 // $3 y
		    sat temp16 
  code_02F2:
		    lst temp0 
		    lat temp16 
		    div
		    sal local_0000 
		    lst temp16 
		    mul
		    push
		    lat temp0 
		    lt?
		    bnt code_0305
		    +al local_0000 
  code_0305:
		    push2
		    pushi 4 // $4 x
		    lat temp5 
		    add
		    push
		    lsl local_0000 
		    pushi 4 // $4 x
		    lat temp2 
		    add
		    mul
		    push
		    calle 999 public_999_0003 4
		    sat temp10 
		    lst temp16 
		    pushi 4 // $4 x
		    lat temp1 
		    add
		    mul
		    sat temp11 
		    pushi 190 // $BE show
		    sub
		    push
		    ldi 2 // $2 -info-
		    div
		    sat temp12 
		    pushi 320 // $140 theObj
		    lat temp10 
		    sub
		    push
		    ldi 2 // $2 -info-
		    div
		    sat temp13 
		    lst temp12 
		    lat temp11 
		    add
		    sat temp14 
		    lst temp13 
		    lat temp10 
		    add
		    sat temp15 
		    pushi 35 // $23 window
		    push0
		    lag global_0009 
		    send 4

		    bnt code_037A
		    pushi 179 // $B3 top
		    push1
		    lst temp12 
		    pushi 180 // $B4 left
		    push1
		    lst temp13 
		    pushi 182 // $B6 right
		    push1
		    lst temp15 
		    pushi 181 // $B5 bottom
		    push1
		    lst temp14 
		    pushi 177 // $B1 open
		    push0
		    pushi 35 // $23 window
		    push0
		    lag global_0009 
		    send 4

		    send 28

  code_037A:
		    lal local_0000 
		    sat temp20 
		    lat temp0 
		    bnt code_04EF
		    push2
		    pushi 110 // $6E respondsTo
		    push1
		    pushi 357 // $165 yOffset
		    pushi 35 // $23 window
		    push0
		    lag global_0009 
		    send 4

		    send 6

		    bnt code_03A3
		    pushi 357 // $165 yOffset
		    push0
		    pushi 35 // $23 window
		    push0
		    lag global_0009 
		    send 4

		    send 4

  code_03A3:
		    add
		    sat temp18 
		    pushi 4 // $4 x
		    pushi 110 // $6E respondsTo
		    push1
		    pushi 356 // $164 xOffset
		    pushi 35 // $23 window
		    push0
		    lag global_0009 
		    send 4

		    send 6

		    bnt code_03C7
		    pushi 356 // $164 xOffset
		    push0
		    pushi 35 // $23 window
		    push0
		    lag global_0009 
		    send 4

		    send 4

  code_03C7:
		    add
		    sat temp17 
		    sat temp19 
		    pushi 118 // $76 first
		    push0
		    lag global_0009 
		    send 4

		    sat temp8 
  code_03D5:
		    lat temp8 
		    bnt code_04EF
		    pushi 17 // $11 signal
		    push0
		    push1
		    push
		    callk NodeValue 2

		    sat temp9 
		    send 4

		    push
		    ldi 4 // $4 x
		    and
		    not
		    bnt code_04E1
		    pushi 108 // $6C isKindOf
		    push1
		    class InvI
		    push
		    lat temp9 
		    send 6

		    bnt code_04E1
		    pushi 17 // $11 signal
		    push0
		    lat temp9 
		    send 4

		    push
		    ldi 128 // $80 timer
		    and
		    not
		    bnt code_04AC
		    pushi 10 // $A nsLeft
		    push1
		    lst temp17 
		    lst temp2 
		    pushi 3 // $3 y
		    pushi 5 // $5 view
		    push0
		    lat temp9 
		    send 4

		    push
		    pushi 6 // $6 loop
		    push0
		    lat temp9 
		    send 4

		    push
		    pushi 7 // $7 cel
		    push0
		    lat temp9 
		    send 4

		    push
		    callk CelWide 6

		    sat temp6 
		    sub
		    push
		    ldi 2 // $2 -info-
		    div
		    add
		    push
		    pushi 9 // $9 nsTop
		    push1
		    lst temp18 
		    lst temp1 
		    pushi 3 // $3 y
		    pushi 5 // $5 view
		    push0
		    lat temp9 
		    send 4

		    push
		    pushi 6 // $6 loop
		    push0
		    lat temp9 
		    send 4

		    push
		    pushi 7 // $7 cel
		    push0
		    lat temp9 
		    send 4

		    push
		    callk CelHigh 6

		    sat temp7 
		    sub
		    push
		    ldi 2 // $2 -info-
		    div
		    add
		    push
		    lat temp9 
		    send 12

		    pushi 12 // $C nsRight
		    push1
		    pushi 10 // $A nsLeft
		    push0
		    lat temp9 
		    send 4

		    push
		    lat temp6 
		    add
		    push
		    pushi 11 // $B nsBottom
		    push1
		    pushi 9 // $9 nsTop
		    push0
		    lat temp9 
		    send 4

		    push
		    lat temp7 
		    add
		    push
		    lat temp9 
		    send 12

		    -at temp20 
		    bnt code_049A
		    lst temp17 
		    lat temp2 
		    add
		    sat temp17 
		    jmp code_04BE
  code_049A:
		    lal local_0000 
		    sat temp20 
		    lst temp18 
		    lat temp1 
		    add
		    sat temp18 
		    lat temp19 
		    sat temp17 
		    jmp code_04BE
  code_04AC:
		    pushi 10 // $A nsLeft
		    push0
		    lat temp9 
		    send 4

		    sat temp17 
		    pushi 9 // $9 nsTop
		    push0
		    lat temp9 
		    send 4

		    sat temp18 
  code_04BE:
		    pushi 190 // $BE show
		    push0
		    lat temp9 
		    send 4

		    lst temp9 
		    lap param2 
		    eq?
		    bnt code_04E1
		    pushi 183 // $B7 setCursor
		    push2
		    pushi 5 // $5 view
		    push1
		    lag global_0001 
		    send 8

		    pushi 191 // $BF highlight
		    push0
		    lat temp9 
		    send 4

  code_04E1:
		    pushi 68 // $44 next
		    push1
		    lst temp8 
		    lag global_0009 
		    send 6

		    sat temp8 
		    jmp code_03D5
  code_04EF:
		    pushi 182 // $B6 right
		    push0
		    pushi 35 // $23 window
		    push0
		    lag global_0009 
		    send 4

		    send 4

		    push
		    pushi 180 // $B4 left
		    push0
		    pushi 35 // $23 window
		    push0
		    lag global_0009 
		    send 4

		    send 4

		    sub
		    push
		    lat temp5 
		    sub
		    push
		    ldi 2 // $2 -info-
		    div
		    sat temp17 
		    pushi 181 // $B5 bottom
		    push0
		    pushi 35 // $23 window
		    push0
		    lag global_0009 
		    send 4

		    send 4

		    push
		    pushi 179 // $B3 top
		    push0
		    pushi 35 // $23 window
		    push0
		    lag global_0009 
		    send 4

		    send 4

		    sub
		    sat temp11 
		    ldi 32767 // $7FFF 
		    sat temp18 
		    pushi 118 // $76 first
		    push0
		    lag global_0009 
		    send 4

		    sat temp8 
  code_0541:
		    lat temp8 
		    bnt code_060F
		    pushi 108 // $6C isKindOf
		    push1
		    class InvI
		    push
		    push1
		    lst temp8 
		    callk NodeValue 2

		    sat temp9 
		    send 6

		    not
		    bnt code_0601
		    pushi 3 // $3 y
		    pushi 5 // $5 view
		    push0
		    lat temp9 
		    send 4

		    push
		    pushi 6 // $6 loop
		    push0
		    lat temp9 
		    send 4

		    push
		    pushi 7 // $7 cel
		    push0
		    lat temp9 
		    send 4

		    push
		    callk CelWide 6

		    sat temp6 
		    pushi 3 // $3 y
		    pushi 5 // $5 view
		    push0
		    lat temp9 
		    send 4

		    push
		    pushi 6 // $6 loop
		    push0
		    lat temp9 
		    send 4

		    push
		    pushi 7 // $7 cel
		    push0
		    lat temp9 
		    send 4

		    push
		    callk CelHigh 6

		    sat temp7 
		    pushi 17 // $11 signal
		    push0
		    lat temp9 
		    send 4

		    push
		    ldi 128 // $80 timer
		    and
		    not
		    bnt code_05D4
		    lst temp18 
		    ldi 32767 // $7FFF 
		    eq?
		    bnt code_05B8
		    lst temp11 
		    lat temp7 
		    sub
		    sat temp18 
  code_05B8:
		    pushi 10 // $A nsLeft
		    push1
		    lst temp17 
		    pushi 9 // $9 nsTop
		    push1
		    lst temp18 
		    pushi 11 // $B nsBottom
		    push1
		    lst temp11 
		    pushi 12 // $C nsRight
		    push1
		    lst temp17 
		    lat temp6 
		    add
		    push
		    lat temp9 
		    send 24

  code_05D4:
		    pushi 10 // $A nsLeft
		    push0
		    lat temp9 
		    send 4

		    push
		    lat temp6 
		    add
		    sat temp17 
		    pushi 9 // $9 nsTop
		    push0
		    lat temp9 
		    send 4

		    sat temp18 
		    pushi 17 // $11 signal
		    push1
		    pushi 17 // $11 signal
		    push0
		    lat temp9 
		    send 4

		    push
		    ldi -5 // $FFFB 
		    and
		    push
		    pushi 190 // $BE show
		    push0
		    lat temp9 
		    send 10

  code_0601:
		    pushi 68 // $44 next
		    push1
		    lst temp8 
		    lag global_0009 
		    send 6

		    sat temp8 
		    jmp code_0541
  code_060F:
		    ret*/
)
/******************************************************************************/