/******************************************************************************/
(script 936)
/******************************************************************************/
(include "sci.sh")
/******************************************************************************/
(use "window")
(use "main")
/******************************************************************************/
(class BorderWindow of Window
	(properties
		top 0
		left 0
		bottom 0
		right 0
		color 0
		back 5
		priority 15
		window 0
		type 0
		title 0
		brTop 0
		brLeft 0
		brBottom 190
		brRight 320
		underBits 0
		pUnderBits 0
		topBordColor 7
		lftBordColor 6
		rgtBordColor 4
		botBordColor 3
		bevelWid 3
		shadowWid 2
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
	)
	(method (dispose)
		SetPort(NULL)
		
		Graph(8  underBits)
		Graph(8  pUnderBits)
		Graph(13 lsTop lsLeft lsBottom lsRight)
		
		(super:dispose())
	)
	(method (open)
		(var temp0, temp1)
		
		SetPort(NULL)
		
		= temp1 1
		
		(if(<> priority -1)
			= temp1 (| temp1 2)
		)
		
		= lsTop    (- top bevelWid)
		= lsLeft   (- left bevelWid)
		= lsRight  (+ (+ right bevelWid) shadowWid)
		= lsBottom (+ (+ bottom bevelWid) shadowWid)
		
		= underBits Graph(7 lsTop lsLeft lsBottom lsRight 1)

		(if(<> priority -1)
			= pUnderBits Graph(7 lsTop lsLeft lsBottom lsRight 2)
		)
		
		proc_02E2(
			top left bottom right 
			back topBordColor lftBordColor botBordColor rgtBordColor 
			bevelWid shadowWid priority temp1
		)
		Graph(12 lsTop lsLeft lsBottom lsRight 1)
		= type $81
		(super:open())
	)
)

/******************************************************************************/
(class InsetWindow of BorderWindow // $022A
	(properties
		top 0
		left 0
		bottom 0
		right 0
		color 0
		back 5
		priority 15
		window 0
		type 0
		title 0
		brTop 0
		brLeft 0
		brBottom 190
		brRight 320
		underBits 0
		pUnderBits 0
		topBordColor 5
		lftBordColor 4
		rgtBordColor 2
		botBordColor 1
		bevelWid 3
		shadowWid 2
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		ck 3
		insideColor 2
		topBordColor2 0
		lftBordColor2 1
		botBordColor2 5
		rgtBordColor2 4
		topBordHgt 10
		botBordHgt 24
		sideBordWid 2
		shadWid 0
		bevWid 2
		xOffset 0
		yOffset 0
	)
	(method (open) // method_016A
		(var temp0, temp1, temp2, temp3, temp4, temp5)
		
		= temp0 1
		
		(if(<> priority -1)
			= temp0 (| temp0 2)
		)
		
		= temp2 top
		= temp3 left
		= temp4 bottom
		= temp5 right
		
		= top     (- top (+ bevelWid topBordHgt))
		= left    (- left (+ bevelWid sideBordWid))
		= bottom  (+ bottom (+ bevelWid botBordHgt))
		= right   (+ right (+ bevelWid sideBordWid))
		
		= xOffset (+ bevelWid sideBordWid)
		= yOffset (+ bevelWid topBordHgt)
		
		(super:open())
		proc_02E2(
			temp2 temp3  temp4  temp5 
		    insideColor topBordColor2 lftBordColor2 botBordColor2 rgtBordColor2
		    bevWid  shadWid priority temp0 
		)
		= temp1 GetPort()
		SetPort(NULL)
		
		Graph(12
			(- temp2 bevWid)
			(- temp3 bevWid)
			(+ temp4 bevWid)
			(+ temp5 bevWid)
			1
		)
		SetPort(temp1)
	)
)
/******************************************************************************/
(procedure 
  (proc_02E2 
	param1 param2 param3 param4 param5 param6 param7 param8
	param9 param10 param11 param12 param13
  )
	(var temp0, temp1)
	
	= temp0 GetPort()
	SetPort(NULL)
	
	Graph(11
		param1 param2 (+ param3 1) (+ param4 1) param13 param5 param12)
		
	= param1 (- param1 param10)
	= param2 (- param2 param10)
	= param4 (+ param4 param10)
	= param3 (+ param3 param10)
	
		    
    Graph(11
    	param1 param2 (+ param1 param10) param4 param13 param6 param12)

    Graph(11
    	(- param3 param10) param2 param3 param4 param13 param8 param12)
    	
    = temp1 0
  	(while(< temp1 param10)
  		Graph(4
  			(+ param1 temp1)
  			(+ param2 temp1)
  			(- param3 (+ temp1 1))
  			(+ param2 temp1)
  			param7
  			param12
  			-1
  		)
  		Graph(4
  			(+ param1 temp1)
  			(- param4 (+ temp1 1))
  			(- param3 (+ temp1 1))
  			(- param4 (+ temp1 1))
  			param9
  			param12
  			-1
		)
		++temp1 
	)
  
  
	(if(param11)
		Graph(11 
			(+ param1 param11)  param4  (+ param3 param11)  (+ param4 param11)  param13  0  param12)
		Graph(11 
			param3 (+ param2 param11)  (+ param3 param11)  param4 param13 0 param12)
	)
  
	SetPort(temp0)
)
/******************************************************************************/
