/******************************************************************************/
(script 992)
/******************************************************************************/
(include "sci.sh")
/******************************************************************************/
(use "main")
(use "obj")
/******************************************************************************/
(class Cycle of Obj
	(properties
		client 0
		caller 0
		cycleDir cdFORWARD
		cycleCnt 0
		completed 0
	)
	(method (init newClient)
		(if(paramTotal)
			= client newClient
		)
		= cycleCnt 0
		= completed FALSE
	)
	(method (nextCel)
		++cycleCnt
		(if(<= cycleCnt (send client:cycleSpeed))
			(send client:cel)
		)(else
			= cycleCnt 0
			(if(& (send client:signal) $1000)
				(send client:cel)
			)(else
				(+ (send client:cel) cycleDir)
		    )
		)
	)
	(method (cycleDone))
	(method (motionCue)
		(send client:cycler(NULL))
		(if(completed and IsObject(caller))
			(send caller:cue())
		)
		(self:dispose())
	)
)
/******************************************************************************/
(class Fwd of Cycle
	(properties
		client 0
		caller 0
		cycleDir cdFORWARD
		cycleCnt 0
		completed 0
	)
	(method (doit)
		(var theCel)
		= theCel (self:nextCel())
		(if(> theCel (send client:lastCel))
			(self:cycleDone())
		)(else
			(send client:cel(theCel))
		)
	)
	(method (cycleDone)
		(send client:cel(0))
	)
)
/******************************************************************************/
(class Walk of Fwd
	(properties
		client 0
		caller 0
		cycleDir 1
		cycleCnt 0
		completed 0
	)
	(method (doit)
		(if(not (send client:isStopped))
			(super:doit())
		)
	)
)
/******************************************************************************/
(class CT of Cycle
	(properties
		client 0
		caller 0
		cycleDir cdFORWARD
		cycleCnt 0
		completed 0
		endCel 0
	)
	(method (init theClient theEndCel theCycleDir theCaller)
		(var theLastCel)
		(super:init(theClient))
		= cycleDir theCycleDir
		(if(== paramTotal 4)
			= caller theCaller
		)
		= theLastCel (send client:lastCel)
		(if(> theEndCel theLastCel)
		    = endCel theLastCel
		)(else
		    = endCel theEndCel
		)
	)
	(method (doit)		
		(var temp0, temp1)
		= temp1 (send client:lastCel)
		(if(> endCel temp1)
		    = endCel temp1
		)
		= temp0 (self:nextCel())
		
		(if(> temp0 temp1)
		    (send client:cel( 0 ))
		)(else
			(if(< temp0 0)
		    	(send client:cel( temp1 ))
		    )(else
		    	(send client:cel( temp0 ))
		    )
		)
		(if((== cycleCnt 0) and (== endCel (send client:cel)))
			(self:cycleDone())
		)
	)
	(method (cycleDone)
		= completed TRUE
		(if(caller)
			= global[$25] TRUE
		)(else
			(self:motionCue())
		)
	)
)
/******************************************************************************/
(class End of CT
	(properties
		client 0
		caller 0
		cycleDir cdFORWARD
		cycleCnt 0
		completed 0
		endCel 0
	)
	(method (init theClient theCaller)
		(if(== paramTotal 2)
			(super:init(theClient (send theClient:lastCel) cdFORWARD theCaller))
		)(else
			(super:init(theClient (send theClient:lastCel) cdFORWARD NULL))
		)
	)
)
/******************************************************************************/
(class Beg of CT
	(properties
		client 0
		caller 0
		cycleDir cdFORWARD
		cycleCnt 0
		completed 0
		endCel 0
	)
	(method(init theClient theCaller)
		(if(== paramTotal 2)
		    (super:init(theClient 0 cdBACKWARD theCaller))
		)(else
		    (super:init(theClient 0 cdBACKWARD NULL))
		)
	)
)
/******************************************************************************/
(class SyncWalk of Fwd
	(properties
		client 0
		caller 0
		cycleDir cdFORWARD
		cycleCnt 0
		completed 0
		xLast 0
		yLast 0
	)
	(method (doit) // method_033E
		(var temp0)
		    (if(IsObject(= temp0 (send client:mover)))
		    	(if( (<> (send client:x) xLast) or (<> (send client:y) yLast) )
		    		= xLast (send client:x)
		    		= yLast (send client:y)
		    		(super:doit())
		    	)
		)
	)
	(method (nextCel)
		= cycleCnt (send client:cycleSpeed)
		(super:nextCel())
	)
)
/******************************************************************************/
(class Motion of Obj
	(properties
		client 0
		caller 0
		x 0
		y 0
		dx 0
		dy 0
		{b-moveCnt} 0
		{b-i1} 0
		{b-i2} 0
		{b-di} 0
		{b-xAxis} 0
		{b-incr} 0
		completed 0
		xLast 0
		yLast 0
	)
	(method (init param1 param2 param3 param4)
		(var temp0, temp1, temp2, temp3)
		(if(>= paramTotal 1)
		    = client param1
			(if(>= paramTotal 2)
		    	= x param2
				(if(>= paramTotal 3)
		    		= y param3
					(if(>= paramTotal 4)
						= caller param4
					)
				)
			)
		)
		= completed 0
		= {b-moveCnt} 0
		= xLast 0
		= yLast 0
		
		(if(= temp3 (send client:cycler))
			(send temp3:cycleCnt(0))
		)
		= temp2 (send client:x)
		= temp3 (send client:y)
		(if(GetDistance(temp2 temp3 x y))
			(send client:setHeading(
				GetAngle(
					temp2
					temp3
					x
					y
				)
			))
		)
		InitBresen(self)
	)
	(method (doit)
		DoBresen(self)
	)
	(method (moveDone)
		= completed TRUE
		(if(caller)
			= global[$25] 1
		)(else
			(self:motionCue())
		)
	)
	(method (setTarget newX newY)
		(if(paramTotal)
			= x newX
			= y newY
		)
	)
	(method (onTarget)
		(if((== (send client:x) x) and
			(== (send client:y) y))
				return(TRUE)
		)
		return(FALSE)
	)
	(method (motionCue)
		(send client:mover(NULL))
		(if(completed and IsObject(caller))
			(send caller:cue())
		)
		(self:dispose())
	)
)
/******************************************************************************/
(class MoveTo of Motion
	(properties
		client 0
		caller 0
		x 0
		y 0
		dx 0
		dy 0
		{b-moveCnt} 0
		{b-i1} 0
		{b-i2} 0
		{b-di} 0
		{b-xAxis} 0
		{b-incr} 0
		completed 0
		xLast 0
		yLast 0
	)
	(method (init params)
		(super:init(rest params))
	)
	(method (onTarget)
		(if((<= Abs(- (send client:x) x) (send client:xStep))
			and
			(<= Abs(- (send client:y) y) (send client:yStep)))
					return(TRUE)
		)
		return(FALSE)
	)
)
/******************************************************************************/
