/******************************************************************************/
(script 815)
/******************************************************************************/
(include "sci.sh")
/******************************************************************************/
(use "main")
(use "stopwalk")
(use "user")
(use "features")
/******************************************************************************/
(local
  local_0000[9] = ( $00 $04 $02 $05 $01 $07 $03 $06 $08 )
)
/******************************************************************************/
(class LLEgo of Ego
	(properties
		x 0
		y 0
		z 0
		heading 0
		noun 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		description 0
		sightAngle 26505
		actions 0
		onMeCheck 26505
		approachX 0
		approachY 0
		approachDist 0
		{_approachVerbs} 26505
		lookStr 0
		yStep 2
		view 0
		loop 0
		cel 0
		priority 0
		underBits 0
		signal 8192
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		palette 0
		cycleSpeed 0
		script 0
		cycler 0
		timer 0
		detailLevel 0
		illegalBits 32768
		xLast 0
		yLast 0
		xStep 3
		moveSpeed 0
		blocks 0
		baseSetter 0
		mover 0
		looper 0
		viewer 0
		avoider 0
		code 0
		edgeHit 0
		{_head} 0
		normal 1
		moveHead 1
	)

	(method (dispose)
		(if(_head)
			(send _head:dispose())
		)
		(super:dispose())
	)
	(method (stopUpd)
		(if(_head)
			(send _head:stopUpd())
		)
		(super:stopUpd())
	)
	(method (hide)
		(if(_head)
			(send _head:hide())
		)
		(super:hide())
	)
	(method (headView tView)
		(send _head:view(tView))
		(if(not (& (send _head:signal) 8))
			(send _head:showSelf())
		)
	)
	(method (egoSpeed newSpeed)
		(if(paramTotal)
			(self:
				cycleSpeed(newSpeed)
				moveSpeed(newSpeed)
			)
		)(else
			(self:
				cycleSpeed(global[$A9])
				moveSpeed(global[$A9])
			)
		)
	)
	(method (userSpeed)
		(self:
			cycleSpeed( (send gGame:egoMoveSpeed()) )
			moveSpeed(  (send gGame:egoMoveSpeed()) )
		)
	)
)
/******************************************************************************/
(class Head of Prop
	(properties
		x 0
		y 0
		z 0
		heading 0
		noun 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		description 0
		sightAngle 26505
		actions 0
		onMeCheck 26505
		approachX 0
		approachY 0
		approachDist 0
		{_approachVerbs} 26505
		lookStr 0
		yStep 2
		view 0
		loop 0
		cel 0
		priority 0
		underBits 0
		signal 0
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		palette 0
		cycleSpeed 0
		script 0
		cycler 0
		timer 0
		detailLevel 0
		client 0
		{_cnt} 0
		{_offSet} 0
	)

	(method (init tClient)
		(self: client(tClient) ignoreActors(TRUE) )
		= loop (- NumLoops(self) 1)
		(send tClient:_head(self))
		(super:init())
		(self:hide())
	)
	(method (doit)
		(if( (send client:normal)    and (not (& (send client:signal) 8)) and 
		     (send client:isStopped) and IsObject((send client:cycler)) and
		     (send (send client:cycler):isKindOf(StopWalk)) and
			 (== (send client:view) (send (send client:cycler): vStopped)))
			 	(if( (& signal 4) and not (& signal 2) )
			 		(if(& (send client:signal) 4)
			 			return
			 		)
			 		(self:startUpd())
				)
				(self:showSelf())
				(self:lookAround())
		)(else
			(if(not & signal 8)
				(self:hide())
			)
		)
  		(super:doit())
	)
	(method (showSelf)
		(var temp0)
		(if( & signal 8 )
			(self:cel( (send client:loop) ))
			= _cnt cycleSpeed
			= temp0 0
			(while(<= temp0 7)
		    	(if(== cel local_0000[temp0])
		    		= _offSet temp0
		    	)
		    	++temp0
		    )
		)
		(self:
		    setPri(send client:priority)
		    loop(- NumLoops(self) 1)
		    x(send client:x)
		    y(send client:y)
		    z(CelHigh( view  (send client:loop)  (send client:cel) ))
		    
		    show()
		)
	)
	(method (lookAround)
		(var temp0)
		(if( (send client:moveHead()) and (< --_cnt 1) )
			= _cnt cycleSpeed
		    = temp0 (+ _offSet (- Random(0 2) 1))
		    (if(> temp0 7)
		    	= temp0 0
			)
		    (if(< temp0 0)
		    	= temp0 7
			)
			= cel local_0000[temp0]
		)
	)
)
/******************************************************************************/
