/******************************************************************************/
(script 994)
/******************************************************************************/
(include "sci.sh")
/******************************************************************************/
(use "main")
(use "controls")
(use "polygon")
(use "sound")
(use "syswindow")
(use "cycle")
(use "inv")
(use "user")
(use "obj")
/******************************************************************************/
(instance cast  of EventHandler
	(properties)
)
/******************************************************************************/
(instance features  of EventHandler
	(properties)
)
/******************************************************************************/
(instance theDoits  of EventHandler
	(properties)
)
/******************************************************************************/
(instance fastCast  of EventHandler
	(properties)
)
/******************************************************************************/
(instance sFeatures  of EventHandler
	(properties)
	(method (delete param1)
		(super:delete(param1))
		(if( (global[$22]) and (send param1:isKindOf(Collect))
		    and not EqualsAny(param1 gRegions global[$1C]))
		    	(send param1:
		    		release() 
		    		dispose()
		    	)
		)
	)
)
/******************************************************************************/
(instance sounds  of EventHandler
	(properties)
	(method (pause param1)
		(self:
			eachElementDo(
				#perform mayPause 
					(if(paramTotal)
						param1
					)(else
						1
					)
			)
		)
	)
)
/******************************************************************************/
(instance mayPause  of Code
	(properties)
	(method (doit param1 param2)
  		(if(not (& (send param1:flags) 1))
  			(send param1:pause(param2))
  		)
	)
)
/******************************************************************************/
(instance regions  of EventHandler
	(properties)
)
/******************************************************************************/
(instance locales  of EventHandler
	(properties)
)
/******************************************************************************/
(instance addToPics  of EventHandler
	(properties)
	(method (doit)
		(self:eachElementDo(#perform aTOC))
		AddToPic(elements)
	)
)
/******************************************************************************/
(instance _controls  of Controls
	(properties)
)
/******************************************************************************/
(instance timers  of Set
	(properties)
)
/******************************************************************************/
(instance aTOC  of Code
	(properties)
	(method (doit param1)
		(var temp0, temp1)
		(if(not (| (send param1:signal) $4000))
		    = temp0 (+ (send global[0]:xStep) (/ CelWide((send global[0]:view) 2 0) 2))
		    = temp1 (* (send global[0]:yStep) 2)
		    
		    (send gRoom:addObstacle(
		    	(send (Polygon:new()):
		    		init(
		    			(- (send param1:brLeft) temp0)
		    			(- CoordPri(1 CoordPri(send param1:y)) temp1)
		    			(+ (send param1:brRight) temp0)
		    			(- CoordPri(1 CoordPri(send param1:y)) temp1)
		    			(+ (send param1:brRight) temp0)
		    			(+ (send param1:y) temp1)
		    			(- (send param1:brLeft) temp0)
		    			(+ (send param1:y) temp1)
		    		)
		    		yourself()
		    	)	
		    ))
		)
	)
)
/******************************************************************************/
(class Game of Obj
	(properties
		script 0
		parseLang 1
		printLang 1
		subtitleLang 0
		{_detailLevel} 3
		egoMoveSpeed 0
	)
	(method (init)
		(Motion)
		(Sound)
		ScriptID(932)
			    
		(send (= gCast cast):add())
		(send (= global[$20] features):add())
		(send (= global[$21] sFeatures):add())
		(send (= gSounds sounds):add())
		(send (= gRegions regions):add())
		(send (= global[$1C] locales):add())
		(send (= gAddToPics addToPics):add())
		(send (= gTimers timers):add())
		(send (= global[$4E] theDoits):add())
		(send (= global[$54] fastCast):add())
		    
		= global[$1D] GetSaveDir()
		    
		(Inv:init())
		    
		(if(not global[$50])
		    = global[$50] User
		)
		(send global[$50]:init())
	)
	(method (doit)
		(var temp0)
		(if(send global[$54]:isEmpty())
		    (send gSounds:eachElementDo(#check))
		    (send gTimers:eachElementDo(#doit))
		    (if(global[$19]) 
		    	(send global[$19]:check())
			)
  			Animate( (send gCast:elements) 1 )
		    (if(global[$25])
		   	 	= global[$25] 0
		    	(send gCast:eachElementDo(#motionCue))
			)
		    (if(script)
  				(send script:doit())
 			)
  			(send gRegions:eachElementDo(#doit))
  			(if(== gRoomNumber gRoomNumberExit)
		    	(send global[$50]:doit())
  			)
  			(send global[$4E]:doit())
		    (if(<> gRoomNumber gRoomNumberExit)
		    	(self:newRoom(gRoomNumber))
			)
  			(send gTimers:eachElementDo(#delete))
  			GameIsRestarting(FALSE)
		)(else
  			(while(not (send global[$54]:isEmpty()))
		    	(send global[$54]:eachElementDo(#doit))
		    	(if(send (= temp0 (Event:new)):type)
		    		(send global[$54]:firstTrue(#handleEvent temp0))
				)
  				(send temp0:dispose())
  			)
		)
	)
	(method (play)
		= gGame self	
		= global[$1D] GetSaveDir()
		(if( (not GameIsRestarting()) )
		    GetCWD(global[$1D])
		)
		(self:
			setCursor(gLoadingCursor 1)
			init()
			setCursor(gNormalCursor HaveMouse())
		)
		(while( (not gQuitGame) )
		    (self:doit())
			= global[$12] Wait(gSpeed)
		)
	)
	(method (replay)
		(if(global[$18])
			(send global[$18]:dispose())
		)
		(send global[$21]:release())
		(if(global[$19])
			(send global[$19]:dispose())
		)
		(send gCast:eachElementDo(#perform RU))
		(send gGame:setCursor(gLoadingCursor 1))

		DrawPic((send gRoom:curPic) 100 dpCLEAR global[$28])

		(if(<> global[$24] -1)
		    DrawPic(global[$24] 100 dpNO_CLEAR global[$28])
		)
		(if( (send gRoom:controls) )
			(send (send gRoom:controls):draw())
		)
		(send gAddToPics:doit())
		(send gGame:setCursor(gNormalCursor HaveMouse()))
		
		(SL:doit())
		DoSound(2)
		(Sound:pause(0))

		(while( (not gQuitGame) )
		    (self:doit())
			= global[$12] Wait(gSpeed)
		)
	)
	(method (newRoom newRoomNum)
		(var oldCursor, hEvent)
		(send gAddToPics:
			eachElementDo(#dispose)
			release()
		)
		(send global[$20]:
			eachElementDo(#perform fDC)
			release()
		)
		(send gCast:
			eachElementDo(#dispose)
			eachElementDo(#delete)
		)
		(send gTimers:
			eachElementDo(#delete)
		)
		(send gRegions:
			eachElementDo(#perform DNKR)
			release()			
		)
		(send global[$1C]:
			eachElementDo(#dispose)
			release()
		)
		(send global[$4E]:release())
		Animate(0)
		= gPreviousRoomNumber	gRoomNumberExit
		= gRoomNumberExit		newRoomNum
		= gRoomNumber			newRoomNum
		FlushResources(newRoomNum)
		(self:
			startRoom(gRoomNumberExit)
			checkAni()
		)
		SetSynonyms(gRegions)
  		(while(send (= hEvent (Event:new(evMOUSE))):type)
  			(send hEvent:dispose())
		)
		(send hEvent:dispose())
	)
	(method (startRoom roomNum)
		(if(gDEBUG_ON_EXIT)
			SetDebug()
		)
		(send gRegions:addToFront(= gRoom ScriptID(roomNum)))
		(send gRoom:init())
	)
	(method (restart)
		(if(global[$19])
			(send global[$19]:dispose())
		)
		RestartGame()
	)
	(method (restore strDescription)
		(var gameNum = -1, oldCursor, hSound)
		Load(rsFONT 0)
		Load(rsCURSOR gNormalCursor)
		
		ScriptID(990)

		= oldCursor (self:setCursor(gNormalCursor))
		= hSound (Sound:pause(1))

		(if(GetSaveDisk(TRUE))
			(if(global[$19])
				(send global[$19]:dispose())
			)
			= gameNum (Restore:doit(rest strDescription))
			(if(<> gameNum -1)
				(self:setCursor(gLoadingCursor))
				(if(CheckSaveGame(objectName gameNum global_001B))
					(send gCast:eachElementDo(#dispose))
					(send gCast:eachElementDo(#delete))
					RestoreGame(objectName gameNum global_001B)
				)
  				(else
  					Print(
  						"That game was saved under a different interpreter. It cannot be restored."
  						#font 0
  						#button "OK" 1
  					)
  					(self:setCursor(oldCursor HaveMouse()))
  					= gameNum -1
				)
  			)
  			GetSaveDisk(FALSE)
		)
		(Sound:pause(hSound))
		return(gameNum)
	)
	(method (save)
		(var strDescBuf[20], gameNum, oldCursor, hSound)
		Load(rsFONT 0)
		Load(rsCURSOR gLoadingCursor)
		
		= oldCursor (self:setCursor(gNormalCursor))
		= hSound (Sound:pause(1))
		(if(GetSaveDisk(TRUE))
			(if(global[$19])
				(send global[$19]:dispose())
			)
			= gameNum (Save:doit(@strDescBuf))
			(if(<> gameNum -1)
				= oldCursor (self:setCursor(gLoadingCursor 1))
				(if(not SaveGame(objectName gameNum @strDescBuf global_001B))
					Print(
						"Your save game disk is full. You must either "+
						"use another disk or save over an existing saved game."
						#font 0
						#button "OK" 1
					)
				)
				(self:setCursor(oldCursor HaveMouse()))
			)
  			GetSaveDisk(FALSE)
		)
  		(Sound:pause(hSound))
	)
	(method (changeScore addPoints)
		= gScore (+ gScore addPoints)
		(SL:doit())
	)
	(method (handleEvent pEvent)
		(if(send pEvent:claimed)
		    (1)
		)(else
		    (if((script) and (send script:handleEvent(pEvent)))
		    	(1)
			)(else
  				(if(== (send pEvent:type) $4000)
		    		(self:pragmaFail)
		    	)
		    )
		)
  		(send pEvent:claimed)
	)
	(method (showMem)
		FormatPrint(
		    "Free Heap: %u Bytes\nLargest ptr: %u Bytes\nFreeHunk: %u KBytes\nLargest hunk: %u Bytes"
		    MemoryInfo(miFREEHEAP)
		    MemoryInfo(miLARGESTPTR)		    
		    (>> MemoryInfo(miFREEHUNK) 6)		    
		    MemoryInfo(miLARGESTHUNK)
		)
	)
	(method (setSpeed newSpeed)
		(var oldSpeed)
		= oldSpeed gSpeed
		= gSpeed newSpeed
		return(oldSpeed)
	)
	(method (setCursor csrNumber params)
		(var oldCursor)
		= oldCursor gCurrentCursor
		= gCurrentCursor csrNumber
		
		SetCursor(
		    csrNumber
		    rest params
		)
		
		return(oldCursor)
	)
	(method (checkAni)
		(var hCastMember)
		Animate((send gCast:elements) 0)
		Wait(0)
		Animate((send gCast:elements) 0)
		(while(> Wait(0) global[$1E])
			= hCastMember (send gCast:firstTrue(#isExtra))
			(if(== hCastMember NULL) break)
			
			(send hCastMember:addToPic())
			Animate((send gCast:elements()) 0)
			(send gCast:eachElementDo(#delete))
  		)
	)
	(method (notify))
	(method (setScript newScript params)
		(if(script)
			(send script:dispose())
		)
		(if(newScript)
			(send newScript:init(self rest params))
		)
	)
	(method (cue)
		(if(script)
			(send script:cue())
		)
	)
	(method (quitGame param1)
		(if(not paramTotal or param1)
			= gQuitGame TRUE
		)
	)
	(method (masterVolume param1)
		(if(paramTotal)
			DoSound(0 param1)
		)(else
			DoSound(0)
		)
	)
	(method (detailLevel param1)
		(if(paramTotal)
			= _detailLevel param1
			(send gCast:eachElementDo(#checkDetail))
		)
		return(_detailLevel)
	)
	(method (pragmaFail))
)
/******************************************************************************/
(class Rgn of Obj
	(properties
		script 0
		number 0
		timer 0
		keep 0
		initialized 0
		lookStr 0
	)
	(method (init)
		(if( not initialized )
			= initialized TRUE
			(if( not (send gRegions:contains(self)) )
				(send gRegions:addToEnd(self))
		    )
		    (super:init())
		)
	)
	(method (doit)
		(if(script)
			(send script:doit())
		)
	)
	(method (dispose)
		(send gRegions:delete(self))
		(if(IsObject(script))
			(send script:dispose())
		)
		(if(IsObject(timer))
			(send timer:dispose())
		)
		(send gSounds:eachElementDo(#clean self))
		DisposeScript(number)
	)
	(method (handleEvent pEvent)
		(if(send pEvent:claimed)
			1
		)(else
		    (if(script and (send script:handleEvent(pEvent)) and not(send pEvent:claimed))
		    	(send pEvent:claimed(	
		    		(self:doVerb(
		    			(send pEvent:message)
		    			(if(global[$9] and global[$45] and (== (send pEvent:message) 4))
		    				(send global[$9]:indexOf((send global[$45]:curInvIcon)))
						)
		    		))
		    	))
		    )
		)
		(send pEvent:claimed)
	)
	(method (doVerb param1)
		(if((== param1 2) and (lookStr))
		    FormatPrint("%s" lookStr)
		    return(TRUE)
		)(else
		    return(FALSE)
		)
	)
	(method (setScript newScript params)
		(if(IsObject(script))
		    (send script:dispose())
		)
		(if(newScript)
			(send newScript:init(self rest params))
		)
	)
	(method (cue)
		(if(script)
			(send script:cue())
		)
	)
	(method (newRoom))
	(method (notify))
)
/******************************************************************************/
(class Rm of Rgn
	(properties
		script 0
		number 0
		timer 0
		keep 0
		initialized 0
		lookStr 0
		picture 0
		style 65535
		horizon 0
		controls 0
		north 0
		east 0
		south 0
		west 0
		curPic 0
		picAngle 0
		vanishingX 160
		vanishingY 35536
		obstacles 0
	)
	(method (init)
		= number gRoomNumberExit
		= controls _controls
		= global[$1F] picAngle
		(if(picture)
			(self:drawPic(picture))
		)
		(self:reflectPosn(
		    (send global[$50]:alterEgo)
		    (send (send global[$50]:alterEgo):edgeHit)
		))
		(send (send global[$50]:alterEgo):edgeHit(0))
	)
	(method (doit)
		(var newRoomNum)
		(if(script)
			(send script:doit())
		)
		(if(= newRoomNum (self:edgeToRoom(send (send global[$50]:alterEgo):edgeHit)))
			(self:newRoom(newRoomNum))
		)
	)
	(method (dispose)
		(if(controls)
			(send controls:dispose())
		)
		(if(obstacles)
			(send obstacles:dispose())
		)
		(super:dispose())
	)
	(method (handleEvent pEvent)
		(if(not (super:handleEvent(pEvent)) and controls)
		    (send controls:handleEvent(pEvent))
		)
		return( (send pEvent:claimed) )
	)
	(method (newRoom newRoomNum)
		(send gRegions:
			delete(self)
			eachElementDo(#newRoom newRoomNum)
			addToFront(self)
		)
		= gRoomNumber newRoomNum
		(super:newRoom(newRoomNum))
	)
	(method (setRegions scriptNumbers)
		(var i, scrNum, hScript)
  		(for (= i 0) (< i paramTotal) (++i)
  			= scrNum scriptNumbers[i]
  			= hScript ScriptID(scrNum)
  			(send hScript:number(scrNum))
  			(send gRegions:add(hScript))
  			(if( not(send hScript:initialized) )
  				(send hScript:init())
		    )
		)
	)
	(method (setFeatures features)
		(var i)
		(for (= i 0) (< i paramTotal) (++i)
			(send global[$20]:add(features[i]))
		)
	)
	(method (setLocales scriptNumbers)
		(var i, scrNum, hScript)
		= i 0
  		(if(< i paramTotal)
		    = scrNum scriptNumbers[i]
		    (send (= hScript ScriptID(scrNum)):
		    	number(scrNum)
		    )
			(send global[$1C]:add(hScript))
			(send hScript:init())
			++i
		)
	)
	(method (drawPic picNum picAni)
		(if(global[$A])
			(send global[$A]:
				eachElementDo(#dispose)
				release()
			)
		)
		= curPic picNum
		= global[$24] -1
		DrawPic(
			picNum
		    (if(== paramTotal 2)	
		    	picAni
		    )(else
		    	(if(<> style -1)
		    		style
				)(else
			    	global[$11]
			    )
		   	)
		    TRUE
		    global[$28]
		)
	)
	(method (overlay picNum picAni)
		= global[$24] picNum
		DrawPic(
			picNum
			(if(== paramTotal 2)
		    	picAni 
			)(else
		    	(if(<> style -1)
		    		style
				)(else
			    	global[$11]
			    )
		    )
		    FALSE
		    global[$28]
		)
	)
	(method (addObstacle param1 param2)
		(if(not IsObject(obstacles))
			= obstacles (List:new())
		)
		(send obstacles:add(param1 rest param2))
	)
	(method (reflectPosn param1 param2)
		(switch(param2)
			(case 1
				(send param1:y(188))
			)
			(case 4
				(send param1:x(- 319 (send param1:xStep)))
			)
			(case 3
				(send param1:y(+ horizon (send param1:yStep)))
			)
			(case 2
				(send param1:x(1))
			)
		)
	)
	(method (edgeToRoom param1)
		(switch(param1)
			(case EDGE_TOP
		    	north
			)
			(case EDGE_RIGHT
		    	east
			)
			(case EDGE_BOTTOM
		    	south
			)
			(case EDGE_LEFT
		    	west
			)
		)
	)
	(method (roomToEdge param1)
		(switch(param1)
			(case north
				EDGE_TOP
			)
			(case east
				EDGE_RIGHT
			)
			(case south
				EDGE_BOTTOM
			)
			(case west
				EDGE_LEFT
			)
		)
	)
)
/******************************************************************************/
(class Locale of Obj
	(properties
		number 0
	)
	(method (dispose)
		(send global[$1C]:delete(self))
		DisposeScript(number)
	)
	(method (handleEvent pEvent)
		(send pEvent:claimed)
	)
)
/******************************************************************************/
(class SL of Obj
	(properties
		state DISABLED
		code  NULL
	)
	(method (doit)/*
		(var temp0[$40])
		(if(code)
		    (send code:doit(temp0))
		    DrawStatus(
		    	(if(state)
		    		temp0
		   	 	)(else
		    		0
		    	)
		    )
		)*/
	)
	(method (enable) 
		= state ENABLED
		(self:doit())
	)
	(method (disable)
		= state DISABLED
		(self:doit())
	)
)
/******************************************************************************/
(instance RU  of Code
	(method (doit param1)
		(var newSignal)
		(if((send param1:underBits))
			= newSignal (send param1:signal)
			= newSignal (| newSignal 1)
			= newSignal (& newSignal $FFFB)
			(send param1:
				underBits(0)
				signal(newSignal)
			)
		)
	)
)
/******************************************************************************/
(instance DNKR  of Code
	(properties)
	(method (doit param1)
		(if( not (send param1:keep) )  	
			(send param1:dispose())
		)
	)
)
/******************************************************************************/
(instance fDC  of Code
	(method (doit param1)
		(if(send param1:respondsTo(#delete))
		    (send param1:
		    	signal(& (send param1:signal) $FFDF)
		    	dispose()
		    	delete()
		    )
		)(else
			(send param1:dispose())
		)
	)
)
/******************************************************************************/
(procedure (GetSaveDisk fSAVEDISK)
	(var btnPressed, temp1[40], temp41[40], temp81[40])
		   
	= btnPressed 1 // btnOK
	DeviceInfo(0 global_001B @temp1)
	DeviceInfo(@temp41)
	(if(DeviceInfo(2 @temp1 @temp41) and DeviceInfo(3 @temp41))
		(if(fSAVEDISK)
			Format(@temp81 "Please insert your SAVE GAME disk in drive %s." @temp41)
		)(else
			Format(@temp81 "Please insert your GAME disk in drive %s." @temp41)
		)
		DeviceInfo(4)
		(if(fSAVEDISK)
			= btnPressed Print(
				@temp81
				#font 0
				#button "OK" 1
				#button "Cancel" 0
				#button "Change Directory" 2
			)
		)(else
  			= btnPressed Print(
  				@temp81
  				#font 0
  				#button "OK" 1
  			)
		)
		(if(== btnPressed 2) // btnChangeDirectory
			SRChangeDirectory(global_001B)
		)
	)
	return(btnPressed)
)
/******************************************************************************/