/******************************************************************************/
(script 934)
/******************************************************************************/
(include "sci.sh")
/******************************************************************************/
(use "main")
(use "iconbar")
(use "obj")
/******************************************************************************/
(class Slider of IconI
	(properties
		view -1
		loop -1
		cel -1
		nsLeft 0
		nsTop -1
		nsRight 0
		nsBottom 0
		state 0
		cursor -1
		type $4000
		message -1
		modifiers 0
		signal 1
		helpStr 0
		maskView 0
		maskLoop 0
		maskCel 0
		highlightColor 0
		lowlightColor 0
		sliderView 0
		sliderLoop 0
		sliderCel 0
		sTop 0
		sLeft 0
		sRight 0
		maxY 0
		minY 0
		underBits 0
		yStep 1
		theObj 0
		selector 0
		bottomValue 0
		topValue 0
	)

	(method (doit params)
		(if(theObj)
			proc999_7(theObj  selector  rest params)
		)
	)
	(method (show params)
		(super:show(rest params))
		(if(not sRight)
			= sLeft nsLeft
			= sRight nsRight
			= maxY (- nsBottom CelHigh(sliderView sliderLoop sliderCel))
			= minY nsTop
		)
		= sTop (self:valueToPosn())
		DrawCel(sliderView sliderLoop sliderCel sLeft sTop -1)
		Graph(12
			- nsTop 1
			- nsLeft 1
			+ nsBottom 2
			+ nsRight 2
			1
		)
	)
	(method (select param1)
		(var temp0)
		(if(paramTotal and param1)
  			(while(<> (send (= temp0 (Event:new())):type) evMOUSERELEASE)
		    	(send temp0:localize())
		    	(if(< (send temp0:y) (- sTop yStep))
		    		(self:move(yStep not(& signal $200)))
  				)(else
  					(if(> (send temp0:y) (+ sTop yStep))
		    			(self:move(neg(yStep) not(& signal $200)))
		    		)
		    	)
  				(send temp0:dispose())
			)
  			(if(& signal $200)
		    	(self:doit( (self:posnToValue(sTop)) ))
		    )
  			(send temp0:dispose())
		)(else
		    return(TRUE)	
		)
	)
	(method (highlight))
	(method (advance)
		(self:
			move(
		    	proc999_3( 
		    		yStep
		    		(- sTop (self:valueToPosn(
			   			(+ (self:doit()) proc999_0(- topValue bottomValue))
					)))
				)
				not(& signal $200)
			)
		)
		(if(& signal $200)
			(self:doit(
				(self:posnToValue(sTop))
			))
		)
	)
	(method (retreat)
		(self:
			move(
		    	proc999_2(
		    		neg(yStep)
		    		(- sTop
		    			(self:valueToPosn(- (self:doit()) proc999_0(- topValue bottomValue)))
		    		)
		   	 	)
		   	 	not(& signal $200)
		   	)
		)
		(if(& signal $200)
			(self:doit(
				(self:posnToValue(sTop))
			))
		)
	)
	(method (move param1 param2)
		(var temp0, temp1, temp2, temp3, temp4, temp5, temp6, temp7)
		(if(paramTotal)
			= temp7 param2
		)(else 
			= temp7 0
		)
		= temp5 proc999_0(param1)
		= temp4 param1
		(while(<= yStep Abs(temp4))
		    = temp0 (- sTop (* temp5 yStep))
		    = temp1 CelHigh(sliderView sliderLoop sliderCel)
		    (if(< temp0 minY)
		    	(minY)
		    )(else
  				(if(> temp0 maxY)
		    		= sTop (maxY)
		    	)(else
		    		= sTop (temp0)
		    	)
		    )
  			= temp2 PicNotValid()
  			PicNotValid(TRUE)
  			DrawCel(view loop cel nsLeft nsTop -1)
  			DrawCel(sliderView sliderLoop sliderCel sLeft sTop -1)
  			Graph(12
  				(- nsTop 1)
  				(- nsLeft 1)
  				(+ nsBottom 2)
  				(+ nsRight 2)
  				1
  			)
  			PicNotValid(temp2)
  			= temp3 (self:posnToValue(sTop))
  			
		    (if(temp7) 
		    	= temp6 (self:doit(temp3))
		    )(else
  				= temp6 (self:doit())
			)
  			= temp4 (- temp4 (* yStep temp5))
		)
  		return(temp6)
	)
	(method (valueToPosn param1)
		(var temp0)
		(if(paramTotal)
		    = temp0 (param1) 
		)(else
  			= temp0 (self:doit())
		)
		(if((< temp0 topValue) and (< temp0 bottomValue))
		    (if(< bottomValue topValue)
		    	return(maxY)
		    )
		    return(minY)
		)(else
  			(if((> temp0 topValue) and  (> temp0 bottomValue))
		    	(if(< bottomValue topValue)
		    		return(minY)
		    	)
		    	return(maxY)
		    )
		    (+ minY (/ 
		    	(* Abs(- topValue temp0) (- maxY minY))
			   	Abs(- topValue bottomValue)
			))
		)
	)
	(method (posnToValue param1)
		return(+
			bottomValue
		    (/ (* (- maxY param1) (- topValue bottomValue)) (- maxY minY))		    
		)
	)
)
/******************************************************************************/
(class GameControls of IconBar
	(properties
		elements 0
		size 0
		height 200
		underBits 0
		oldMouseX 0
		oldMouseY 0
		curIcon 0
		highlightedIcon 0
		prevIcon 0
		curInvIcon 0
		useIconItem 0
		helpIconItem 0
		port 0
		window 0
		state 0
		activateHeight 0
		y 0
		okButton 0
	)
	(method (show)
		(var temp0, temp1, temp2, temp3, temp4)
		(send gSounds:pause())
		(if(global[$4D] and (send global[$4D]:respondsTo(#stop)))
			(send global[$4D]:stop())
		)
		= state (| state $20)
		(if(IsObject(window))
			(send window:open())
		)(else
			= window (send (send global[$26]:new()):
				top(46)
				left(24)
				bottom(155)
				right(296)
				priority(15)
				open()
				yourself()
			)
		)
		= temp0 30
		= temp1 30
		= temp2 FirstNode(elements)
  		(while(temp2)
  			= temp3 NextNode(temp2)
  			(if(not IsObject(= temp4 NodeValue(temp2)))
  				return
  			)
  			(if( not(& (send temp4:signal()) $80)
			 and(<= (send temp4:nsRight) 0))
		    	(send temp4:show(temp0 temp1))
		    	= temp0 (+ 20 (send temp4:nsRight))
			)(else
  				(send temp4:show())
			)
  			= temp2 temp3
		)
		(if(not okButton)
			= okButton NodeValue(self:first)
		)
		(if(curIcon)
			(send gGame:setCursor(
				gCurrentCursor
				TRUE
		    	(+  (send curIcon:nsLeft)
   					(/ (- (send curIcon:nsRight) (send curIcon:nsLeft)) 2)
   				)
		    	(- (send curIcon:nsBottom) 3)
			))
		)
		(self:doit() hide())
	)
	(method (hide)
		(if(window)
			(send window:dispose())
		)
		(if(& state $20)
			(send gSounds:pause(NULL))
			= state (& state $FFDF)
		)
	)
	(method (select param1 param2)
		(if(>= paramTotal 2)
			(send param1:select(param2))
		)(else
			(send param1:select(NULL))
		)
	)
	(method (swapCurIcon))
	(method (advanceCurIcon))
	(method (dispatchEvent param1)
		(if(& (send param1:type) $40)
			(switch(send param1:message) 
				(case 5
					(send param1:dispose())
					(if(IsObject(highlightedIcon) and
					 (send highlightedIcon:respondsTo(#retreat)))
					 	(send highlightedIcon:retreat())
					 	return(FALSE)
					)(else
						(if((not IsObject(highlightedIcon)) or
						 (& (send highlightedIcon:signal) $100))
						 	(self:advance())
						 	return(FALSE)
						)
		    		)
				)
  				(case 1
  					(send param1:dispose())
  					(if( IsObject(highlightedIcon) and
  					  	 (send highlightedIcon:respondsTo(#advance)))
  							(send highlightedIcon:advance())
  							return(FALSE)
  					)(else
  						(if(not IsObject(highlightedIcon) or
  							(& (send highlightedIcon:signal) $100))
  								(self:retreat())
  						)
  						return(FALSE)
  					)
				)
  				(default
  					(super:dispatchEvent(param1))
		    	)
			)
		)(else
  			(super:dispatchEvent(param1))
		)
	)
)
/******************************************************************************/
(class ControlIcon of IconI
	(properties
		view -1
		loop -1
		cel -1
		nsLeft 0
		nsTop -1
		nsRight 0
		nsBottom 0
		state 0
		cursor -1
		type $4000
		message -1
		modifiers 0
		signal 1
		helpStr 0
		maskView 0
		maskLoop 0
		maskCel 0
		highlightColor 0
		lowlightColor 0
		theObj 0
		selector 0
	)
	(method (select params)
		(if(theObj)
		    (if(super:select(rest params))
		    	(if(& signal $40)
		    		(if(global[$3F])
		    			(send global[$3F]:hide())
		    		)(else
		    			(GameControls:hide())
		    		)
				)
				proc999_7(theObj selector)
		    )
		)(else
  			(super:select(rest params))
		)
	)
)
/******************************************************************************/
