/******************************************************************************/
(script 995)
/******************************************************************************/
(include "sci.sh")
/******************************************************************************/
(use "main")
(use "controls")
(use "iconbar")
(use "window")
(use "obj")
/******************************************************************************/
(local
  local_0000 = 0
)
/******************************************************************************/
(class InvI of IconI
	(properties
		view 0
		loop 0
		cel 0
		nsLeft 0
		nsTop 0
		nsRight 0
		nsBottom 0
		state 0
		cursor 999
		type $4000
		message 4
		modifiers 0
		signal 0
		helpStr 0
		maskView 0
		maskLoop 0
		maskCel 0
		highlightColor 0
		lowlightColor 0
		description 0
		owner 0
		script 0
		value 0
	)
	(method (show)
		(var temp0[4])
		DrawCel(view loop cel nsLeft nsTop -1)
	)
	(method (highlight param1)
		(var temp0, temp1, temp2, temp3, temp4)
		
		= temp4 (if(paramTotal and param1)
		    highlightColor
		)(else
		    lowlightColor
		)
		= temp0 (- nsTop 2)
		= temp1 (- nsLeft 2)
		= temp2 (+ nsBottom 1)
		= temp3 (+ nsRight 1)
		
		Graph(4 temp0 temp1 temp0 temp3 temp4 -1 -1)
		Graph(4 temp0 temp3 temp2 temp3 temp4 -1 -1)
		Graph(4 temp2 temp3 temp2 temp1 temp4 -1 -1)
		Graph(4 temp2 temp1 temp0 temp1 temp4 -1 -1)
		
		Graph(
			12
			(- nsTop 2)
			(- nsLeft 2)
			(+ nsBottom 2)
			(+ nsRight 2)
			1
		)
	)
	(method (onMe param1)
		return(if(super:onMe(param1))
			not(& signal 4)
		)
	)
	(method (ownedBy param1)
		return(== owner param1)
	)
	(method (moveTo param1)
		= owner param1
		(if ((value) and (= param1 global[0]))
			(send gGame:changeScore(value))
			= value 0
		)
		return(self)
	)
	(method (doVerb param1)
		(switch(param1)
			(case 2
				FormatPrint("%s" description)
			)
		)
	)
)
/******************************************************************************/
//(define _D Print)
(class Inv of IconBar
	(properties
		elements 0
		size 0
		height 0
		underBits 0
		oldMouseX 0
		oldMouseY 0
		curIcon 0
		highlightedIcon 0
		prevIcon 0
		curInvIcon 0
		useIconItem 0
		helpIconItem 0
		port 0
		window 0
		state 0
		activateHeight 0
		y 0
		normalHeading "Roger is carrying:" // String @ $0CF3
		heading 0
		empty "nothing!" // String @ $0D06
		curScore "Score: %d out of %d" // String @ $0D0F
		showScore 1
		iconBarInvItem 0
		okButton 0
		selectIcon 0
	)
	(method (init)
		= gInv self
		= heading normalHeading
	)
	(method (doit) // method_0819
		(var temp0, temp1, temp2, temp3, temp4, temp5, temp6, temp7)
		(while((= temp1 (Event:new())) and (& state $20))
		    = temp7 0
		    (send temp1:localize())
		   
		    

		    (if((curIcon) and (not (send temp1:modifiers)) and (<> curIcon selectIcon))
		    	(if(
				    (== (send temp1:type) 1)
					or
				   	(if ((== (send temp1:type) evKEYBOARD) and (== (send temp1:message) KEY_RETURN))
				   		= temp7 1 
					)
					or
				   	(if ((== (send temp1:type) $100) and (= temp7 1)))
				   )
				    	(if((<> curIcon helpIconItem) or (& (send helpIconItem:signal) $10))
						    (send temp1:
						    	type($4000)
						    	message(send curIcon:message)
						    )
						)
				)		    
			) 

		    
		    MapKeyToDir(temp1)
		    
			(if((== (= temp2 (send temp1:type)) 1) and (send temp1:modifiers))
		    	(self:advanceCurIcon())
		    	(send temp1:claimed(TRUE))
		    )(else
	  			(if((== temp2 0) and (= temp0 (self:firstTrue(#onMe temp1))) and (<> temp0 highlightedIcon))
			    	(self:highlight(temp0))
			    )(else
		  			(if(
		  				(== temp2 1) or
		  				(if ((== temp2 4) and (== (send temp1:message) KEY_RETURN))) or
		  				(== temp2 $100)
		  			   )
						(if((IsObject(highlightedIcon)) and (self:select(highlightedIcon (== temp2 1))))
						    (if(== highlightedIcon okButton)
						    	(asm jmp code_0B56)
							)
				  
				  			(if(== highlightedIcon helpIconItem)
							    (if(<> (send highlightedIcon:cursor) -1)
							    	(send gGame:setCursor(send helpIconItem:cursor))
					 			)
					 			
					  			(if(helpIconItem)
							    	(send helpIconItem:signal(
							    		| (send helpIconItem:signal) $10
							    	))
							    )
							)(else
				  				= curIcon highlightedIcon
				  				(send gGame:setCursor( (send curIcon:cursor) 1 ))
				  			)
						)
					)(else
			  			(if(& temp2 $40)
						    (switch(send temp1:message) 
						    	(case 3
						    		(self:advance())
								)
								(case 7
						    		(self:retreat())
								)
								(case 1
						    		(self:retreat(local_0000))
								)
								(case 5
						    		(self:advance(local_0000))
								)
								(case 0
									(if(& temp2 4)
										(self:advanceCurIcon())
									)
								)
							)
						)(else
				  			(if(== temp2 4)
							    (switch(send temp1:message)
							    	(case 9
							    		(self:advance())
									)
									(case $F00
							    		(self:retreat())
									)
								)
							)(else
								(if((== temp2 $4000) and (= temp0 (self:firstTrue(#onMe temp1))))
							    	(if(== (send temp1:message) 6)
								    	(if((temp0) and (send temp0:helpStr))
								    		FormatPrint(995 0   (send temp0:helpStr))
										)
						  				(send helpIconItem:
						  					signal(
						  						& (send helpIconItem:signal) $FFEF	
						  					)
						  				)
						  				(send gGame:setCursor(999))
									)(else
					  					(if(== temp0 okButton)
					  						(asm jmp code_0B56)
					  					)
										(if(not (send temp0:isKindOf(InvI)))
										    (if(self:select(temp0 not(temp7)))
											    = curIcon temp0
											    
											    (send gGame:setCursor(
											    	(send curIcon:cursor)
											    	1
											    ))
										    )
										)(else  
										    (if(curIcon)
											    (if(send curIcon:isKindOf(InvI))
												    (send temp0:
												    	doVerb(
												    		(send curIcon:message)
												    		(self:indexOf(curIcon))
												    	)
												    )
												)(else
									  				(send temp0:doVerb(send temp1:message))
									  			)
									  		)
								  		)
								  	)
							  	)
						  	)
					  	)
					)
				)
			) 
  			(send temp1:dispose())
		)
(asm code_0B56:)
		(send temp1:dispose())
		(self:hide())
	)
	(method (showSelf param1)
		(send global[8]:pause())
		(if(global[$4D] and (send global[$4D]:respondsTo(#stop)))
			(send global[$4D]:stop())
		)
		(if(send global[$45]:height)
			(send global[$45]:hide())
		)
		(if(not window)
			= window (SysWindow:new())
		)
		(if(send window:window)
			(send window:dispose())
			= window NULL
		)
		(if(not okButton)
			= okButton NodeValue(self:first)
		)
		= curIcon NULL
		(send gGame:setCursor(send selectIcon:cursor))
		(self:
			show(
				(if(paramTotal)
					param1
				)(else
					global[0]
				)
			)
			doit()
		)
	)
	(method (show param1)
		= state (| state $20)
		
		proc_01A2(
			(if(paramTotal)
				param1
			)(else
				global[0]
			)
			(send global[$45]:curIcon)
		)
	)
	(method (hide)
		(if(& state $20)
			(send global[8]:pause(0))
			= state (& state $FFDF)
		)
		(if(window)
			(send window:dispose())
		)
		(if(IsObject(curIcon) and (send curIcon:isKindOf(InvI)))
			(if(not (send global[$45]:curInvIcon))
				(send global[$45]:enable(
					(send global[$45]:useIconItem)
				))
			)
			(send global[$45]:
				curIcon(
		    		(send (send global[$45]:useIconItem):
		    			cursor(send curIcon:cursor)		
		    			yourself()
		    		)
		    	)
		    	curInvIcon(curIcon)
		    )
		    (if(send curIcon:cursor)
		    	(send gGame:setCursor(
		    		(send curIcon:cursor)
		    		TRUE
		    	))
		    )
		)
	)
	(method (advance param1)
		(var temp0, temp1, temp2, temp3)
		= temp1 
			(if(paramTotal)
				param1
			)(else 
				1
			)
		= temp2 (self:indexOf(highlightedIcon))
		= temp3 (+ temp2 temp1)
		(while(1)
  			= temp0 (self:at(
		    	(if(<= temp3 size)
		    		temp3
		    	)(else
  					(% temp3 (- size 1))
  				)
  			))
  			(if(not IsObject(temp0))
  				= temp0 NodeValue(self:first)
			)
			(if(not (& (send temp0:signal) 4))
				break
			)
			++temp3
		)
  		(send gGame:
  			setCursor(
  				gCurrentCursor
  				TRUE
  				(+ (send temp0:nsLeft) (/ (- (send temp0:nsRight) (send temp0:nsLeft)) 2))
  				(- (send temp0:nsBottom) 3)
  			)
  		)
  		(self:highlight(temp0))
	)
	(method (retreat param1)
		(var temp0, temp1, temp2, temp3)
		= temp1 
			(if(paramTotal)
				param1
			)(else 
				1
			)
		= temp2 (self:indexOf(highlightedIcon))
		= temp3 (- temp2 temp1)
		(while(1)
  			= temp0 (self:at(temp3))
  			(if(not IsObject(temp0))
  				= temp0 NodeValue(self:last)
			)
			(if(not (& (send temp0:signal) 4))
				break
			)
			--temp3
		)
  		(send gGame:
  			setCursor(
  				gNormalCursor
  				TRUE
  				(+ (send temp0:nsLeft) (/ (- (send temp0:nsRight) (send temp0:nsLeft)) 2))
  				(- (send temp0:nsBottom) 3)
  			)
  		)
  		(self:highlight(temp0))
	)
	(method (advanceCurIcon)
		(var temp0)
		= temp0 curIcon
		(while(send (= temp0 (self:at(% (+ (self:indexOf(temp0)) 1) size))):isKindOf(InvI)))
		= curIcon temp0
		(send gGame:setCursor((send curIcon:cursor) TRUE))
	)
	(method (ownedBy param1)
		(self:firstTrue(#ownedBy param1))
	)
)
/******************************************************************************/
(procedure (proc_01A2 param1 param2) of Inv
	(var temp0, temp1, temp2, temp3, temp4, temp5, temp6, temp7,
		 temp8, temp9, temp10, temp11, temp12, temp13, temp14, temp15, temp16, temp17, temp18, temp19, temp20, temp21)
	= temp5 0
	= temp4 0
	= temp3 0
	= temp2 0
	= temp1 0
	= temp0 0
	= temp8 (send gInv:first)
	(while(temp8)
		(if(send (= temp9 NodeValue(temp8)):isKindOf(InvI))
			(if(send temp9:ownedBy(param1))
				(send temp9:signal(& (send temp9:signal) $FFFB))
				++temp0
			    = temp6 CelWide((send temp9:view) (send temp9:loop) (send temp9:cel))
			    (if(> temp6 temp2)
			    	= temp2 temp6
			    )
			    = temp7 CelHigh((send temp9:view) (send temp9:loop) (send temp9:cel))
		    	(if(> temp7 temp1)
		    		= temp1 temp7
		    	)
		    )(else
				(send temp9:
					signal(| (send temp9:signal) 4)
				)
			)
		)(else
			++temp3
			= temp5 (+ temp5 CelWide((send temp9:view) (send temp9:loop) (send temp9:cel)))
			= temp7 CelHigh((send temp9:view) (send temp9:loop) (send temp9:cel))
			(if(> temp7 temp4)
	    		= temp4 temp7
	    	)
	   	)
		= temp8 (send gInv:next(temp8))
	)
	(if(not temp0)
		return(FormatPrint("%s %s" normalHeading empty))
	)
    (if(> (* (= temp16 Sqrt(temp0)) temp16) temp0)
    	--temp16 
	)
	
	(if(> temp16 3)
    	= temp16 3 
	)
	
	= local_0000 (/ temp0 temp16)
	(if(< (* temp16 local_0000) temp0)
    	++local_0000 
	)
    = temp10 proc999_3(
    	(+ 4 temp5)
    	(* local_0000 (+ 4 temp2))
    )
    
    = temp12 (/ (- 190 (= temp11 (* temp16 (+ 4 temp1)))) 2)
    = temp13 (/ (- 320 temp10) 2)
    = temp14 (+ temp12 temp11)
    = temp15 (+ temp13 temp10)
    (if(send gInv:window)
		(send (send gInv:window):
			top(temp12)
			left(temp13)
			right(temp15)
			bottom(temp14)
			open()
		)
	)
	= temp20 local_0000
	(if(temp0)
	    = temp18 
	    	(+	2
	    		(if(send (send gInv:window):respondsTo(#yOffset))
	    			(send (send gInv:window):yOffset)
	    		)
	    	)
	    = temp19 = temp17
	    	(+ 	4
	    		(if(send (send gInv:window):respondsTo(#xOffset))
					(send (send gInv:window):xOffset)
				)
			)
		= temp8 (send gInv:first)

		(while(temp8)
			(if(not(& (send (= temp9 NodeValue(temp8)):signal) 4) and (send temp9:isKindOf(InvI)))
					(if(not(& (send temp9:signal) $80))				
						(send temp9:   
							nsLeft
							    (+ temp17 
							    	(/ (- temp2 (= temp6 CelWide( (send temp9:view) (send temp9:loop) (send temp9:cel) ))) 2)
								)
							nsTop
								(+
									temp18
								    (/
									    (- 
									    	temp1
									    	(= temp7 CelHigh( (send temp9:view) (send temp9:loop) (send temp9:cel) ))
									    )
									    2
									)
								)
						)
				
						(send temp9:
							nsRight(+ (send temp9:nsLeft) temp6)
						    nsBottom(+ (send temp9:nsTop) temp7)
						)
						(if(--temp20) 
							= temp17 (+ temp17 temp2)
						)(else
							= temp20 local_0000
							= temp18 (+ temp18 temp1)
							= temp17 temp19
						)
					)(else
						= temp17 (send temp9:nsLeft)
						= temp18 (send temp9:nsTop)
					)
			)
			(send temp9:show())
			(if(== temp9 param2)
				(send gGame:setCursor(5 TRUE))
				(send temp9:highlight())
			)
			= temp8 (send gInv:next(temp8))
		)
	)
	= temp17 
		(/ 
			(- 
				(- 
					(send (send gInv:window):right) 
					(send (send gInv:window):left)
				) 
				temp5
			) 
			2
		)
	= temp11 
		(-
			(send (send gInv:window):bottom)	
			(send (send gInv:window):top)	
		)
	= temp18 $7FFF
	= temp8 (send gInv:first())
	(while(temp8)
		(if(not(send (= temp9 NodeValue(temp8)):isKindOf(InvI)))
			= temp6 CelWide( (send temp9:view) (send temp9:loop) (send temp9:cel) )
			= temp7 CelHigh( (send temp9:view) (send temp9:loop) (send temp9:cel) )
		    (if(not(& (send temp9:signal) $80))
			    (if(== temp18 $7FFF)
			    	= temp18 (- temp11 temp7)
	  			)
  				(send temp9:
  					nsLeft(temp17)
  					nsTop(temp18)
  					nsBottom(temp11)
  					nsRight(+ temp17 temp6)
  				)
  			)
			= temp17 (+ (send temp9:nsLeft) temp6)
			= temp18 (send temp9:nsTop)
		
	   	 	(send temp9:
	    		signal(& (send temp9:signal) $FFFB)
	    		show()
	    	)
  		)
		= temp8 (send gInv:next(temp8))
	)
)
/******************************************************************************/