/******************************************************************************/
(script 813)
(version 2)
/******************************************************************************/
(include "sci.sh")
/******************************************************************************/
(use "main")
(use "controls")
(use "polypath")
(use "cycle")
(use "game")
(use "user")
(use "obj")
/******************************************************************************/
(publics
	0 eRS
	1 lRS
)
/******************************************************************************/
(instance _controls  of Controls
	(properties)
)
/******************************************************************************/
(class LLRoom of Rm
	(properties
		script 0
		number 0
		timer 0
		keep 0
		initialized 0
		lookStr 0
		picture 0
		style -1
		horizon 0
		controls 0
		north 0
		east 0
		south 0
		west 0
		curPic 0
		picAngle 0
		vanishingX 160
		vanishingY 35536
		obstacles 0
	)
	(method (init)
		(var temp0, temp1)
		= number gRoomNumberExit
		= controls {_controls}
		= global[$1F] picAngle
		(if(picture)
			(self:drawPic(picture))
		)
		(if(not (send gCast:contains(global[0])))
			return(0)
		)
		(if(script)
			return(0)
		)
		(if(not (send global[0]:normal))
			return(0)
		)
		(if(EqualsAny(style 40 41 42 43))
		    = temp0 (+ 1 (/ CelWide( (send (User:alterEgo):view) 
		       (send (User:alterEgo):loop) (send (User:alterEgo):cel) ) 2))
		    = temp1 (+ 1 (/ CelHigh( (send (User:alterEgo):view) 
		       (send (User:alterEgo):loop) (send (User:alterEgo):cel) ) 2))
		    (switch((send (User:alterEgo):edgeHit))
		    	(case 1
		    		(send (User:alterEgo):y(188)) 
		    	)
		    	(case 4
		    		(send (User:alterEgo):x(- 319 temp0)) 
		    	)
		    	(case 3
		    		(send (User:alterEgo):y(+ horizon temp1)) 
		    	)
		    	(case 2
		    		(send (User:alterEgo):x(+ 0 temp0)) 
		    	)
		    )
		    (send (User:alterEgo):
		    	edgeHit(0)
		    	userSpeed()
		    )
		    proc000_3()
		)(else
			(self: setScript(eRS 0 global[$C]))
		)
	)
	(method (doit)
		(var temp0)
		(if(script)
			return(send script:doit())
		)
  		(if(not(send gCast:contains(global[0])))
  			return(0)
  		)
  		(switch((send (User:alterEgo):edgeHit))
  			(case 1
  				= temp0 north
  			)
  			(case 2
  				= temp0 east
  			)
  			(case 3
  				= temp0 south
  			)
  			(case 4
  				= temp0 west
  			)
  			(default
  				= temp0 0
  			)
  		)
  		(if(temp0)
  			(self:setScript(lRS 0 temp0))
  		)
	)
)
/******************************************************************************/
(instance public lRS  of Script
	(properties)
	(method (changeState newState)
		(var temp0, temp1)
		(switch(= state newState)
			(case 0
				proc000_2()
				= temp1 CelWide( (send global[0]:view) (send global[0]:loop) (send global[0]:cel) )
				(switch(register)
					(case (send client:north)
						(send gRoom:newRoom(register))
					)
					(case (send client:south)
						= temp0 CelHigh( (send global[0]:view) (send global[0]:loop) (send global[0]:cel) )
						(send global[0]:
							setMotion(PolyPath (send global[0]:x) (+ 189 temp0) self)
						)
					)
					(case (send client:east)						
						(send global[0]:
							setMotion(PolyPath (+ 319 temp1) (send global[0]:y) self)
						)
					)
					(case (send client:west)						
						(send global[0]:
							setMotion(PolyPath (- 0 temp1) (send global[0]:y) self)
						)
					)
				)
			)
  			(case 1
  				(send global[0]:hide())
  				= cycles 2
		    )
  			(case 2
  				(send gRoom:
  					setScript(0)
  					newRoom(register)
  				)
		    )
		)
	)
)
/******************************************************************************/
(instance public eRS  of Script
	(properties)
	(method (changeState newState)
		(var temp0, temp1)
		(switch(= state newState)
			(case 0
		    	= cycles 0
		    	proc000_2()
				= temp0 CelHigh( (send global[0]:view) (send global[0]:loop) (send global[0]:cel) )
				= temp1 CelWide( (send global[0]:view) (send global[0]:loop) (send global[0]:cel) )
				(switch(register)
					(case (send client:north)
						proc_03DE()
						(send global[0]:y(
							(+ (send gRoom:horizon) (send global[0]:yStep))
						))
						= cycles 1
					)
					(case (send client:south)
						proc_03DE()
						
						(send global[0]:
							y(+ 189 temp0)
							setMotion(
								MoveTo
		    					(send global[0]:x)
		    					(- 189 (* (send global[0]:yStep) 2))
		    					self
		    				)
		    			)
					)
					(case (send client:east)	
						proc_042B()
						(send global[0]:
		    				x(+ 319 (/ temp1 2))
		    				setMotion(MoveTo (- 319 (+ (* (send global[0]:xStep) 2) 10)) (send global[0]:y) self)
		    			)
					)
					(case (send client:west)	
						proc_042B()
						(send global[0]:
		    				x(- 0 (/ temp1 2))
		    				setMotion(
		    					MoveTo 
		    					(+ 0 (+ (* (send global[0]:xStep) 2) 10))
		    					(send global[0]:y)	
		    					self
		    				)
		    			)
					)
					(default
						= cycles 1
					)
				)
			)
  			(case 1
  				(send global[0]:userSpeed())
  				proc000_3()
  				(self:dispose())
		    )
		)
	)
)
/******************************************************************************/
(procedure (proc_03DE)/*
		    pushi 4 // $4 x
		    push0
		    lag global[0] 
		    send 4

		    push
		    ldi 0 // $0 species
		    lt?
		    bnt code_0404
		    pushi 4 // $4 x
		    push1
		    push0
		    pushi 54 // $36 xStep
		    push0
		    lag global[0] 
		    send 4

		    push
		    ldi 2 // $2 -info-
		    mul
		    add
		    push
		    lag global[0] 
		    send 6

		    jmp code_042A
  code_0404:
		    pushi 4 // $4 x
		    push0
		    lag global[0] 
		    send 4

		    push
		    ldi 319 // $13F canInput
		    gt?
		    bnt code_042A
		    pushi 4 // $4 x
		    push1
		    pushi 319 // $13F canInput
		    pushi 54 // $36 xStep
		    push0
		    lag global[0] 
		    send 4

		    push
		    ldi 2 // $2 -info-
		    mul
		    sub
		    push
		    lag global[0] 
		    send 6

  code_042A:
		    ret*/
	(if(< (send global[0]:x) 0)
		(send global[0]:x(+ 0 (* (send global[0]:xStep) 2)))
	)(else
		(if(> (send global[0]:x) 319)
			(send global[0]:x((- 319 (* (send global[0]:xStep) 2))))
		)
	)
)
/******************************************************************************/
(procedure (proc_042B)
	(if(< (send global[0]:y) (send gRoom:horizon))
		(send global[0]:y(+ (send global[0]:horizon) (* (send global[0]:yStep) 2)))
	)(else
		(if(> (send global[0]:y) 189)
			(send global[0]:y((- 189 (* (send global[0]:yStep) 2))))
		)
	)
)
/******************************************************************************/