/******************************************************************************/
(script 989)
/******************************************************************************/
(include "sci.sh")
/******************************************************************************/
(use "main")
(use "obj")
/******************************************************************************/
(class Sound of Obj
	(properties
		nodePtr 0
		handle 0
		flags 0
		number 0
		vol 127
		priority 0
		loop 1
		signal 0
		prevSignal 0
		dataInc 0
		min 0
		sec 0
		frame 0
		client 0
		owner 0
	)
	(method (new pOwner)
		(var hOwner=NULL)
		(if(paramTotal)
			= hOwner pOwner
		)
		(send (super:new()):
			owner(hOwner)
			yourself()
		)
	)
	(method (init)
		= signal 0
		= prevSignal 0
		(send gSounds:add(self))
		DoSound(6 self)
	)
	(method (dispose)
		(send gSounds:delete(self))
		(if(nodePtr)
			DoSound(7 self)
			= nodePtr NULL
		)
		(super:dispose())
	)
	(method (play params)
		(var temp0)
		= temp0 paramTotal
		(if(paramTotal and IsObject(params[- paramTotal 1]))
			= temp0 (- paramTotal 1)
			= client params[temp0]
		)(else
			= client NULL
		)
		(self:init())
		(if(not loop)
			= loop 1
		)
		(if(temp0)
			= vol params
		)(else
			= vol 127
		)
		DoSound(8 self 0)
	)
	(method (stop)
		(if(nodePtr)
			DoSound(9 self)
		)
	)
	(method (pause param1)
		(if(not paramTotal)
			= param1 1
		)
		(if(self:isMemberOf(Sound))
			DoSound(10 self param1)
		)(else
			DoSound(10 NULL param1)
		)
	)
	(method (hold param1)
		(if(not paramTotal)
			= param1 1
		)
		DoSound(12 self param1)
	)
	(method (release)
		DoSound(12 self NULL)
	)
	(method (fade  param1 param2 param3 param4)
		(var temp0)
		= temp0 paramTotal
		(if(paramTotal and IsObject(param1[- paramTotal 1]))
			= temp0 (- paramTotal 1)
			= client param1[temp0]
		)
		(if(temp0)
			DoSound(11 self param1 param2 param3 param4)
		)(else
			DoSound(11 self 0 25 10 1)
		)
	)
	(method (mute param1)
		(if(not paramTotal)
			= param1 1
		)
		DoSound(13 self param1)
	)
	(method (setVol newVolume)
		DoSound(14 self newVolume)
	)
	(method (setPri newPriority)
		DoSound(15 self newPriority)
	)
	(method (setLoop newLoop)
		DoSound(16 self newLoop)
	)
	(method (send param1 param2 param3)
		(if(<= 1 param1 and <= param1 15)
			DoSound(18 self param1 param2 param3)
		)
	)
	(method (check)
		DoSound(17 self)
		(if(signal)
			= prevSignal signal
			= signal 0
			(if(IsObject(client))
				(send client:cue(self))
			)
		)
	)
	(method (clean param1)
		(if(not owner or == owner param1)
			(self:dispose())
		)
	)
	(method (playBed param1)
		(var temp0)
		= temp0 paramTotal
		(if(paramTotal and IsObject(param1[- paramTotal 1]))
			= temp0 - paramTotal 1
			= client param1[temp0]
		)(else
			= client NULL
		)
		(self:init())
		(if(not loop)
			= loop 1
		)
		(if(temp0)
			= vol param1
		)(else
			= vol 127
		)
		DoSound(8 self 1)
	)
	(method (changeState)
		DoSound(20 self)
	)
)
/******************************************************************************/
